/* Orientation.c generated by valac 0.26.1, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2009-2014 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self, Rotation rotation);
Rotation* orientation_to_rotations (Orientation self, int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);


gchar* orientation_to_string (Orientation self) {
	gchar* result = NULL;
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 101 "Orientation.c"
		{
			gchar* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp0_ = g_strdup ("top-left");
#line 22 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp0_;
#line 22 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 110 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 114 "Orientation.c"
		{
			gchar* _tmp1_ = NULL;
#line 25 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = g_strdup ("top-right");
#line 25 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp1_;
#line 25 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 123 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 127 "Orientation.c"
		{
			gchar* _tmp2_ = NULL;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = g_strdup ("bottom-right");
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp2_;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 136 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 140 "Orientation.c"
		{
			gchar* _tmp3_ = NULL;
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = g_strdup ("bottom-left");
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp3_;
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 149 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 153 "Orientation.c"
		{
			gchar* _tmp4_ = NULL;
#line 34 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = g_strdup ("left-top");
#line 34 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp4_;
#line 34 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 162 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 166 "Orientation.c"
		{
			gchar* _tmp5_ = NULL;
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = g_strdup ("right-top");
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp5_;
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 175 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 179 "Orientation.c"
		{
			gchar* _tmp6_ = NULL;
#line 40 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_ = g_strdup ("right-bottom");
#line 40 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp6_;
#line 40 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 188 "Orientation.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 192 "Orientation.c"
		{
			gchar* _tmp7_ = NULL;
#line 43 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7_ = g_strdup ("left-bottom");
#line 43 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp7_;
#line 43 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 201 "Orientation.c"
		}
		default:
		{
			gchar* _tmp8_ = NULL;
#line 46 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 46 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp8_;
#line 46 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 212 "Orientation.c"
		}
	}
}


Orientation orientation_rotate_clockwise (Orientation self) {
	Orientation result = 0;
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 224 "Orientation.c"
		{
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 230 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 234 "Orientation.c"
		{
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 240 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 244 "Orientation.c"
		{
#line 59 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 59 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 250 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 254 "Orientation.c"
		{
#line 62 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 62 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 260 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 264 "Orientation.c"
		{
#line 65 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 65 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 270 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 274 "Orientation.c"
		{
#line 68 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 68 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 280 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 284 "Orientation.c"
		{
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 290 "Orientation.c"
		}
#line 51 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 294 "Orientation.c"
		{
#line 74 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 74 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 300 "Orientation.c"
		}
		default:
		{
#line 77 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
#line 306 "Orientation.c"
		}
	}
}


Orientation orientation_rotate_counterclockwise (Orientation self) {
	Orientation result = 0;
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 318 "Orientation.c"
		{
#line 84 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 84 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 324 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 328 "Orientation.c"
		{
#line 87 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 87 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 334 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 338 "Orientation.c"
		{
#line 90 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 90 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 344 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 348 "Orientation.c"
		{
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 354 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 358 "Orientation.c"
		{
#line 96 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 96 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 364 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 368 "Orientation.c"
		{
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 374 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 378 "Orientation.c"
		{
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 384 "Orientation.c"
		}
#line 82 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 388 "Orientation.c"
		{
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 394 "Orientation.c"
		}
		default:
		{
#line 108 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:108: rotate_counterclockwise: %d", (gint) self);
#line 400 "Orientation.c"
		}
	}
}


Orientation orientation_flip_top_to_bottom (Orientation self) {
	Orientation result = 0;
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 412 "Orientation.c"
		{
#line 115 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 115 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 418 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 422 "Orientation.c"
		{
#line 118 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 428 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 432 "Orientation.c"
		{
#line 121 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 121 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 438 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 442 "Orientation.c"
		{
#line 124 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 124 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 448 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 452 "Orientation.c"
		{
#line 127 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 127 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 458 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 462 "Orientation.c"
		{
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 468 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 472 "Orientation.c"
		{
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 478 "Orientation.c"
		}
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 482 "Orientation.c"
		{
#line 136 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 136 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 488 "Orientation.c"
		}
		default:
		{
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:139: flip_top_to_bottom: %d", (gint) self);
#line 494 "Orientation.c"
		}
	}
}


Orientation orientation_flip_left_to_right (Orientation self) {
	Orientation result = 0;
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 506 "Orientation.c"
		{
#line 146 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 146 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 512 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 516 "Orientation.c"
		{
#line 149 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 149 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 522 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 526 "Orientation.c"
		{
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 532 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 536 "Orientation.c"
		{
#line 155 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 155 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 542 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 546 "Orientation.c"
		{
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 552 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 556 "Orientation.c"
		{
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 562 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 566 "Orientation.c"
		{
#line 164 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 164 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 572 "Orientation.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 576 "Orientation.c"
		{
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 582 "Orientation.c"
		}
		default:
		{
#line 170 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:170: flip_left_to_right: %d", (gint) self);
#line 588 "Orientation.c"
		}
	}
}


Orientation orientation_perform (Orientation self, Rotation rotation) {
	Orientation result = 0;
	Rotation _tmp0_ = 0;
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp0_ = rotation;
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (_tmp0_) {
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 603 "Orientation.c"
		{
			Orientation _tmp1_ = 0;
#line 177 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = orientation_rotate_clockwise (self);
#line 177 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp1_;
#line 177 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 612 "Orientation.c"
		}
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 616 "Orientation.c"
		{
			Orientation _tmp2_ = 0;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = orientation_rotate_counterclockwise (self);
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp2_;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 625 "Orientation.c"
		}
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 629 "Orientation.c"
		{
			Orientation _tmp3_ = 0;
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = orientation_flip_left_to_right (self);
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp3_;
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 638 "Orientation.c"
		}
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 642 "Orientation.c"
		{
			Orientation _tmp4_ = 0;
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = orientation_flip_top_to_bottom (self);
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp4_;
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 651 "Orientation.c"
		}
		default:
		{
			Rotation _tmp5_ = 0;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = rotation;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:189: perform: %d", (gint) _tmp5_);
#line 660 "Orientation.c"
		}
	}
}


Rotation* orientation_to_rotations (Orientation self, int* result_length1) {
	Rotation* result = NULL;
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 672 "Orientation.c"
		{
			Rotation* _tmp0_ = NULL;
			Rotation* _tmp1_ = NULL;
			gint _tmp1__length1 = 0;
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp0_ = g_new0 (Rotation, 0);
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = _tmp0_;
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1__length1 = 0;
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp1__length1;
#line 687 "Orientation.c"
			}
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp1_;
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 693 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 697 "Orientation.c"
		{
			Rotation* _tmp2_ = NULL;
			Rotation* _tmp3_ = NULL;
			gint _tmp3__length1 = 0;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = g_new0 (Rotation, 1);
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_[0] = ROTATION_MIRROR;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = _tmp2_;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3__length1 = 1;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp3__length1;
#line 714 "Orientation.c"
			}
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp3_;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 720 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 724 "Orientation.c"
		{
			Rotation* _tmp4_ = NULL;
			Rotation* _tmp5_ = NULL;
			gint _tmp5__length1 = 0;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = g_new0 (Rotation, 1);
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5__length1 = 1;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp5__length1;
#line 741 "Orientation.c"
			}
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp5_;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 747 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 751 "Orientation.c"
		{
			Rotation* _tmp6_ = NULL;
			Rotation* _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_ = g_new0 (Rotation, 2);
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_[0] = ROTATION_MIRROR;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7_ = _tmp6_;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7__length1 = 2;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp7__length1;
#line 770 "Orientation.c"
			}
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp7_;
#line 207 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 776 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 780 "Orientation.c"
		{
			Rotation* _tmp8_ = NULL;
			Rotation* _tmp9_ = NULL;
			gint _tmp9__length1 = 0;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_ = g_new0 (Rotation, 2);
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp9__length1 = 2;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp9__length1;
#line 799 "Orientation.c"
			}
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp9_;
#line 210 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 805 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 809 "Orientation.c"
		{
			Rotation* _tmp10_ = NULL;
			Rotation* _tmp11_ = NULL;
			gint _tmp11__length1 = 0;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp10_ = g_new0 (Rotation, 1);
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp10_[0] = ROTATION_CLOCKWISE;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp11_ = _tmp10_;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp11__length1 = 1;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp11__length1;
#line 826 "Orientation.c"
			}
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp11_;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 832 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 836 "Orientation.c"
		{
			Rotation* _tmp12_ = NULL;
			Rotation* _tmp13_ = NULL;
			gint _tmp13__length1 = 0;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp12_ = g_new0 (Rotation, 2);
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp12_[0] = ROTATION_CLOCKWISE;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp13_ = _tmp12_;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp13__length1 = 2;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp13__length1;
#line 855 "Orientation.c"
			}
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp13_;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 861 "Orientation.c"
		}
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 865 "Orientation.c"
		{
			Rotation* _tmp14_ = NULL;
			Rotation* _tmp15_ = NULL;
			gint _tmp15__length1 = 0;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp14_ = g_new0 (Rotation, 1);
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp15_ = _tmp14_;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp15__length1 = 1;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			if (result_length1) {
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
				*result_length1 = _tmp15__length1;
#line 882 "Orientation.c"
			}
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp15_;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 888 "Orientation.c"
		}
		default:
		{
#line 222 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:222: to_rotations: %d", (gint) self);
#line 894 "Orientation.c"
		}
	}
}


void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 226 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 913 "Orientation.c"
		{
			Dimensions _tmp0_ = {0};
#line 233 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp0_ = *dim;
#line 233 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			*result = _tmp0_;
#line 233 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return;
#line 922 "Orientation.c"
		}
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 932 "Orientation.c"
		{
			Dimensions _tmp1_ = {0};
			gint _tmp2_ = 0;
			Dimensions _tmp3_ = {0};
			gint _tmp4_ = 0;
			Dimensions _tmp5_ = {0};
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = *dim;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = _tmp1_.height;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = *dim;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = _tmp3_.width;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			dimensions_init (&_tmp5_, _tmp2_, _tmp4_);
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			*result = _tmp5_;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return;
#line 953 "Orientation.c"
		}
		default:
		{
#line 243 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:243: rotate_dimensions: %d", (gint) self);
#line 959 "Orientation.c"
		}
	}
}


void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 248 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp0_ = *dim;
#line 248 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	orientation_rotate_dimensions (self, &_tmp0_, &_tmp1_);
#line 248 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	*result = _tmp1_;
#line 248 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return;
#line 978 "Orientation.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return self ? g_object_ref (self) : NULL;
#line 985 "Orientation.c"
}


GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
#line 251 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 998 "Orientation.c"
		{
			GdkPixbuf* _tmp0_ = NULL;
			GdkPixbuf* _tmp1_ = NULL;
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp0_ = pixbuf;
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = _g_object_ref0 (_tmp0_);
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp1_;
#line 257 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1012 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1016 "Orientation.c"
		{
			GdkPixbuf* _tmp2_ = NULL;
			GdkPixbuf* _tmp3_ = NULL;
#line 261 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = pixbuf;
#line 261 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (_tmp2_, TRUE);
#line 261 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 261 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp3_;
#line 262 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1030 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1034 "Orientation.c"
		{
			GdkPixbuf* _tmp4_ = NULL;
			GdkPixbuf* _tmp5_ = NULL;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = pixbuf;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = gdk_pixbuf_rotate_simple (_tmp4_, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp5_;
#line 266 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1048 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1052 "Orientation.c"
		{
			GdkPixbuf* _tmp6_ = NULL;
			GdkPixbuf* _tmp7_ = NULL;
#line 270 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_ = pixbuf;
#line 270 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_flip (_tmp6_, FALSE);
#line 270 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 270 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp7_;
#line 271 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1066 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1070 "Orientation.c"
		{
			GdkPixbuf* _tmp8_ = NULL;
			GdkPixbuf* _tmp9_ = NULL;
			GdkPixbuf* _tmp10_ = NULL;
			GdkPixbuf* _tmp11_ = NULL;
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_ = pixbuf;
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp9_ = gdk_pixbuf_rotate_simple (_tmp8_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp10_ = _tmp9_;
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp11_ = gdk_pixbuf_flip (_tmp10_, FALSE);
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp11_;
#line 274 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (_tmp10_);
#line 275 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1092 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1096 "Orientation.c"
		{
			GdkPixbuf* _tmp12_ = NULL;
			GdkPixbuf* _tmp13_ = NULL;
#line 278 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp12_ = pixbuf;
#line 278 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp13_ = gdk_pixbuf_rotate_simple (_tmp12_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 278 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 278 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp13_;
#line 279 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1110 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1114 "Orientation.c"
		{
			GdkPixbuf* _tmp14_ = NULL;
			GdkPixbuf* _tmp15_ = NULL;
			GdkPixbuf* _tmp16_ = NULL;
			GdkPixbuf* _tmp17_ = NULL;
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp14_ = pixbuf;
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp15_ = gdk_pixbuf_rotate_simple (_tmp14_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp16_ = _tmp15_;
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp17_ = gdk_pixbuf_flip (_tmp16_, FALSE);
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp17_;
#line 282 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (_tmp16_);
#line 283 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1136 "Orientation.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1140 "Orientation.c"
		{
			GdkPixbuf* _tmp18_ = NULL;
			GdkPixbuf* _tmp19_ = NULL;
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp18_ = pixbuf;
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp19_ = gdk_pixbuf_rotate_simple (_tmp18_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp19_;
#line 287 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1154 "Orientation.c"
		}
		default:
		{
#line 290 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:290: rotate_pixbuf: %d", (gint) self);
#line 1160 "Orientation.c"
		}
	}
#line 293 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	result = rotated;
#line 293 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return result;
#line 1167 "Orientation.c"
}


void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_ = FALSE;
	GdkPoint _tmp1_ = {0};
	gint _tmp2_ = 0;
	GdkPoint _tmp3_ = {0};
	gint _tmp4_ = 0;
	Dimensions _tmp5_ = {0};
	gint _tmp6_ = 0;
	GdkPoint _tmp7_ = {0};
	gint _tmp8_ = 0;
	GdkPoint _tmp9_ = {0};
	gint _tmp10_ = 0;
	Dimensions _tmp11_ = {0};
	gint _tmp12_ = 0;
	GdkPoint rotated = {0};
#line 297 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 297 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 298 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp0_ = dimensions_has_area (space);
#line 298 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp0_, "space.has_area()");
#line 299 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp1_ = *point;
#line 299 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp2_ = _tmp1_.x;
#line 299 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp2_ >= 0, "point.x >= 0");
#line 300 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp3_ = *point;
#line 300 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp4_ = _tmp3_.x;
#line 300 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp5_ = *space;
#line 300 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp6_ = _tmp5_.width;
#line 300 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp4_ < _tmp6_, "point.x < space.width");
#line 301 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp7_ = *point;
#line 301 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp8_ = _tmp7_.y;
#line 301 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp8_ >= 0, "point.y >= 0");
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp9_ = *point;
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp10_ = _tmp9_.y;
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp11_ = *space;
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp12_ = _tmp11_.height;
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp10_ < _tmp12_, "point.y < space.height");
#line 304 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1232 "Orientation.c"
		{
			GdkPoint _tmp13_ = {0};
#line 309 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp13_ = *point;
#line 309 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated = _tmp13_;
#line 310 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1241 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1245 "Orientation.c"
		{
			Dimensions _tmp14_ = {0};
			gint _tmp15_ = 0;
			GdkPoint _tmp16_ = {0};
			gint _tmp17_ = 0;
			GdkPoint _tmp18_ = {0};
			gint _tmp19_ = 0;
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp14_ = *space;
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp15_ = _tmp14_.width;
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp16_ = *point;
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp17_ = _tmp16_.x;
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = (_tmp15_ - _tmp17_) - 1;
#line 315 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp18_ = *point;
#line 315 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp19_ = _tmp18_.y;
#line 315 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = _tmp19_;
#line 316 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1271 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1275 "Orientation.c"
		{
			Dimensions _tmp20_ = {0};
			gint _tmp21_ = 0;
			GdkPoint _tmp22_ = {0};
			gint _tmp23_ = 0;
			Dimensions _tmp24_ = {0};
			gint _tmp25_ = 0;
			GdkPoint _tmp26_ = {0};
			gint _tmp27_ = 0;
#line 320 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp20_ = *space;
#line 320 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp21_ = _tmp20_.width;
#line 320 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp22_ = *point;
#line 320 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp23_ = _tmp22_.x;
#line 320 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = (_tmp21_ - _tmp23_) - 1;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp24_ = *space;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp25_ = _tmp24_.height;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp26_ = *point;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp27_ = _tmp26_.y;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = (_tmp25_ - _tmp27_) - 1;
#line 322 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1307 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1311 "Orientation.c"
		{
			GdkPoint _tmp28_ = {0};
			gint _tmp29_ = 0;
			Dimensions _tmp30_ = {0};
			gint _tmp31_ = 0;
			GdkPoint _tmp32_ = {0};
			gint _tmp33_ = 0;
#line 326 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp28_ = *point;
#line 326 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp29_ = _tmp28_.x;
#line 326 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = _tmp29_;
#line 327 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp30_ = *space;
#line 327 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp31_ = _tmp30_.height;
#line 327 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp32_ = *point;
#line 327 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp33_ = _tmp32_.y;
#line 327 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = (_tmp31_ - _tmp33_) - 1;
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1337 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1341 "Orientation.c"
		{
			GdkPoint _tmp34_ = {0};
			gint _tmp35_ = 0;
			GdkPoint _tmp36_ = {0};
			gint _tmp37_ = 0;
#line 332 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp34_ = *point;
#line 332 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp35_ = _tmp34_.y;
#line 332 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = _tmp35_;
#line 333 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp36_ = *point;
#line 333 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp37_ = _tmp36_.x;
#line 333 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = _tmp37_;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1361 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1365 "Orientation.c"
		{
			Dimensions _tmp38_ = {0};
			gint _tmp39_ = 0;
			GdkPoint _tmp40_ = {0};
			gint _tmp41_ = 0;
			GdkPoint _tmp42_ = {0};
			gint _tmp43_ = 0;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp38_ = *space;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp39_ = _tmp38_.height;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp40_ = *point;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp41_ = _tmp40_.y;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = (_tmp39_ - _tmp41_) - 1;
#line 339 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp42_ = *point;
#line 339 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp43_ = _tmp42_.x;
#line 339 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = _tmp43_;
#line 340 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1391 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1395 "Orientation.c"
		{
			Dimensions _tmp44_ = {0};
			gint _tmp45_ = 0;
			GdkPoint _tmp46_ = {0};
			gint _tmp47_ = 0;
			Dimensions _tmp48_ = {0};
			gint _tmp49_ = 0;
			GdkPoint _tmp50_ = {0};
			gint _tmp51_ = 0;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp44_ = *space;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp45_ = _tmp44_.height;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp46_ = *point;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp47_ = _tmp46_.y;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = (_tmp45_ - _tmp47_) - 1;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp48_ = *space;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp49_ = _tmp48_.width;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp50_ = *point;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp51_ = _tmp50_.x;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = (_tmp49_ - _tmp51_) - 1;
#line 346 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1427 "Orientation.c"
		}
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1431 "Orientation.c"
		{
			GdkPoint _tmp52_ = {0};
			gint _tmp53_ = 0;
			Dimensions _tmp54_ = {0};
			gint _tmp55_ = 0;
			GdkPoint _tmp56_ = {0};
			gint _tmp57_ = 0;
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp52_ = *point;
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp53_ = _tmp52_.y;
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.x = _tmp53_;
#line 351 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp54_ = *space;
#line 351 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp55_ = _tmp54_.width;
#line 351 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp56_ = *point;
#line 351 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp57_ = _tmp56_.x;
#line 351 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			rotated.y = (_tmp55_ - _tmp57_) - 1;
#line 352 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1457 "Orientation.c"
		}
		default:
		{
#line 355 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:355: rotate_point: %d", (gint) self);
#line 1463 "Orientation.c"
		}
	}
#line 358 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	*result = rotated;
#line 358 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return;
#line 1470 "Orientation.c"
}


void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_ = FALSE;
	GdkPoint derotated = {0};
#line 362 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 362 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 363 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp0_ = dimensions_has_area (space);
#line 363 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_vala_assert (_tmp0_, "space.has_area()");
#line 365 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1491 "Orientation.c"
		{
			GdkPoint _tmp1_ = {0};
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = *point;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated = _tmp1_;
#line 371 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1500 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1504 "Orientation.c"
		{
			Dimensions _tmp2_ = {0};
			gint _tmp3_ = 0;
			GdkPoint _tmp4_ = {0};
			gint _tmp5_ = 0;
			GdkPoint _tmp6_ = {0};
			gint _tmp7_ = 0;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = *space;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = _tmp2_.width;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = *point;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = _tmp4_.x;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = (_tmp3_ - _tmp5_) - 1;
#line 376 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_ = *point;
#line 376 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7_ = _tmp6_.y;
#line 376 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = _tmp7_;
#line 377 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1530 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1534 "Orientation.c"
		{
			Dimensions _tmp8_ = {0};
			gint _tmp9_ = 0;
			GdkPoint _tmp10_ = {0};
			gint _tmp11_ = 0;
			Dimensions _tmp12_ = {0};
			gint _tmp13_ = 0;
			GdkPoint _tmp14_ = {0};
			gint _tmp15_ = 0;
#line 381 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp8_ = *space;
#line 381 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp9_ = _tmp8_.width;
#line 381 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp10_ = *point;
#line 381 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp11_ = _tmp10_.x;
#line 381 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = (_tmp9_ - _tmp11_) - 1;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp12_ = *space;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp13_ = _tmp12_.height;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp14_ = *point;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp15_ = _tmp14_.y;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = (_tmp13_ - _tmp15_) - 1;
#line 383 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1566 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1570 "Orientation.c"
		{
			GdkPoint _tmp16_ = {0};
			gint _tmp17_ = 0;
			Dimensions _tmp18_ = {0};
			gint _tmp19_ = 0;
			GdkPoint _tmp20_ = {0};
			gint _tmp21_ = 0;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp16_ = *point;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp17_ = _tmp16_.x;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = _tmp17_;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp18_ = *space;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp19_ = _tmp18_.height;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp20_ = *point;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp21_ = _tmp20_.y;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = (_tmp19_ - _tmp21_) - 1;
#line 389 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1596 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1600 "Orientation.c"
		{
			GdkPoint _tmp22_ = {0};
			gint _tmp23_ = 0;
			GdkPoint _tmp24_ = {0};
			gint _tmp25_ = 0;
#line 393 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp22_ = *point;
#line 393 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp23_ = _tmp22_.y;
#line 393 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = _tmp23_;
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp24_ = *point;
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp25_ = _tmp24_.x;
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = _tmp25_;
#line 395 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1620 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1624 "Orientation.c"
		{
			GdkPoint _tmp26_ = {0};
			gint _tmp27_ = 0;
			Dimensions _tmp28_ = {0};
			gint _tmp29_ = 0;
			GdkPoint _tmp30_ = {0};
			gint _tmp31_ = 0;
#line 399 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp26_ = *point;
#line 399 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp27_ = _tmp26_.y;
#line 399 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = _tmp27_;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp28_ = *space;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp29_ = _tmp28_.height;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp30_ = *point;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp31_ = _tmp30_.x;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = (_tmp29_ - _tmp31_) - 1;
#line 401 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1650 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1654 "Orientation.c"
		{
			Dimensions _tmp32_ = {0};
			gint _tmp33_ = 0;
			GdkPoint _tmp34_ = {0};
			gint _tmp35_ = 0;
			Dimensions _tmp36_ = {0};
			gint _tmp37_ = 0;
			GdkPoint _tmp38_ = {0};
			gint _tmp39_ = 0;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp32_ = *space;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp33_ = _tmp32_.width;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp34_ = *point;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp35_ = _tmp34_.y;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = (_tmp33_ - _tmp35_) - 1;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp36_ = *space;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp37_ = _tmp36_.height;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp38_ = *point;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp39_ = _tmp38_.x;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = (_tmp37_ - _tmp39_) - 1;
#line 407 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1686 "Orientation.c"
		}
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1690 "Orientation.c"
		{
			Dimensions _tmp40_ = {0};
			gint _tmp41_ = 0;
			GdkPoint _tmp42_ = {0};
			gint _tmp43_ = 0;
			GdkPoint _tmp44_ = {0};
			gint _tmp45_ = 0;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp40_ = *space;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp41_ = _tmp40_.width;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp42_ = *point;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp43_ = _tmp42_.y;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.x = (_tmp41_ - _tmp43_) - 1;
#line 412 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp44_ = *point;
#line 412 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp45_ = _tmp44_.x;
#line 412 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			derotated.y = _tmp45_;
#line 413 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			break;
#line 1716 "Orientation.c"
		}
		default:
		{
#line 416 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:416: rotate_point: %d", (gint) self);
#line 1722 "Orientation.c"
		}
	}
#line 419 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	*result = derotated;
#line 419 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return;
#line 1729 "Orientation.c"
}


void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_ = {0};
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GdkPoint _tmp7_ = {0};
	gint _tmp8_ = 0;
	Dimensions _tmp9_ = {0};
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	GdkPoint _tmp12_ = {0};
	gint _tmp13_ = 0;
	Dimensions _tmp14_ = {0};
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	GdkPoint _tmp17_ = {0};
	gint _tmp18_ = 0;
	Dimensions _tmp19_ = {0};
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	Dimensions _tmp22_ = {0};
	GdkPoint _tmp23_ = {0};
	GdkPoint _tmp24_ = {0};
	Dimensions _tmp25_ = {0};
	GdkPoint _tmp26_ = {0};
	GdkPoint _tmp27_ = {0};
	GdkPoint _tmp28_ = {0};
	GdkPoint _tmp29_ = {0};
	Box _tmp30_ = {0};
#line 423 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 423 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 425 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 425 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left = _tmp0_;
#line 425 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp2_ = top_left;
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp3_ = _tmp2_.x;
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp4_ = *space;
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp5_ = _tmp4_.width;
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp6_ = CLAMP (_tmp3_, 0, _tmp5_ - 1);
#line 427 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left.x = _tmp6_;
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp7_ = top_left;
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp8_ = _tmp7_.y;
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp9_ = *space;
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp10_ = _tmp9_.height;
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp11_ = CLAMP (_tmp8_, 0, _tmp10_ - 1);
#line 428 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left.y = _tmp11_;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp12_ = bottom_right;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp13_ = _tmp12_.x;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp14_ = *space;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp15_ = _tmp14_.width;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp16_ = CLAMP (_tmp13_, 0, _tmp15_ - 1);
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right.x = _tmp16_;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp17_ = bottom_right;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp18_ = _tmp17_.y;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp19_ = *space;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp20_ = _tmp19_.height;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 1);
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right.y = _tmp21_;
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp22_ = *space;
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp23_ = top_left;
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp22_, &_tmp23_, &_tmp24_);
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left = _tmp24_;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp25_ = *space;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp26_ = bottom_right;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp25_, &_tmp26_, &_tmp27_);
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right = _tmp27_;
#line 436 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp28_ = top_left;
#line 436 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp29_ = bottom_right;
#line 436 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	box_from_points (&_tmp28_, &_tmp29_, &_tmp30_);
#line 436 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	*result = _tmp30_;
#line 436 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return;
#line 1851 "Orientation.c"
}


void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	GdkPoint _tmp6_ = {0};
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_ = {0};
	GdkPoint _tmp9_ = {0};
	Box _tmp10_ = {0};
#line 440 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 440 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 442 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 442 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left = _tmp0_;
#line 442 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp2_ = *space;
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp3_ = top_left;
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp2_, &_tmp3_, &_tmp4_);
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	top_left = _tmp4_;
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp5_ = *space;
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	bottom_right = _tmp7_;
#line 447 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp8_ = top_left;
#line 447 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	_tmp9_ = bottom_right;
#line 447 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	box_from_points (&_tmp8_, &_tmp9_, &_tmp10_);
#line 447 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	*result = _tmp10_;
#line 447 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	return;
#line 1905 "Orientation.c"
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
#line 457 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 458 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 458 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1929 "Orientation.c"
		{
			GdkPixbuf* _tmp0_ = NULL;
			GdkPixbuf* _tmp1_ = NULL;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp0_ = pixbuf;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_rotate_simple (_tmp0_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp1_;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 1941 "Orientation.c"
		}
#line 458 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1945 "Orientation.c"
		{
			GdkPixbuf* _tmp2_ = NULL;
			GdkPixbuf* _tmp3_ = NULL;
#line 463 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp2_ = pixbuf;
#line 463 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_rotate_simple (_tmp2_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 463 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp3_;
#line 463 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 1957 "Orientation.c"
		}
#line 458 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 1961 "Orientation.c"
		{
			GdkPixbuf* _tmp4_ = NULL;
			GdkPixbuf* _tmp5_ = NULL;
#line 466 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp4_ = pixbuf;
#line 466 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp5_ = gdk_pixbuf_flip (_tmp4_, TRUE);
#line 466 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp5_;
#line 466 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 1973 "Orientation.c"
		}
#line 458 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1977 "Orientation.c"
		{
			GdkPixbuf* _tmp6_ = NULL;
			GdkPixbuf* _tmp7_ = NULL;
#line 469 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp6_ = pixbuf;
#line 469 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_flip (_tmp6_, FALSE);
#line 469 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = _tmp7_;
#line 469 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 1989 "Orientation.c"
		}
		default:
		{
#line 472 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:472: Unknown rotation: %d", (gint) self);
#line 1995 "Orientation.c"
		}
	}
}


Rotation rotation_opposite (Rotation self) {
	Rotation result = 0;
#line 477 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
	switch (self) {
#line 477 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 2007 "Orientation.c"
		{
#line 479 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ROTATION_COUNTERCLOCKWISE;
#line 479 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 2013 "Orientation.c"
		}
#line 477 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 2017 "Orientation.c"
		{
#line 482 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = ROTATION_CLOCKWISE;
#line 482 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 2023 "Orientation.c"
		}
#line 477 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 477 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 2029 "Orientation.c"
		{
#line 486 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			result = self;
#line 486 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			return result;
#line 2035 "Orientation.c"
		}
		default:
		{
#line 489 "/builddir/build/BUILD/shotwell-0.20.2/src/Orientation.vala"
			g_error ("Orientation.vala:489: Unknown rotation: %d", (gint) self);
#line 2041 "Orientation.c"
		}
	}
}


GType rotation_get_type (void) {
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}



