/* ContainerSourceCollection.c generated by valac 0.26.1, the Vala compiler
 * generated from ContainerSourceCollection.vala, do not modify */

/* Copyright 2011-2014 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A ContainerSourceCollection is for DataSources which maintain links to one or more other*/
/* DataSources, assumed to be of a different type.  ContainerSourceCollection automates the task*/
/* of handling unlinking and relinking and maintaining backlinks.  Unlinked DataSources are*/
/* held in a holding tank, until they are either relinked or destroyed.*/
/**/
/* If the ContainerSourceCollection's DataSources are types that "evaporate" (i.e. they disappear*/
/* when they hold no items), they should use the evaporate() method, which will either destroy*/
/* the DataSource or hold it in the tank (if backlinks are outstanding).*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;
typedef struct _ContainerSourceCollectionPrivate ContainerSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _ContainerSourceCollection {
	DatabaseSourceCollection parent_instance;
	ContainerSourceCollectionPrivate * priv;
};

struct _ContainerSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	void (*notify_container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*notify_container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*notify_container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*notify_backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
	GeeCollection* (*get_containers_holding_source) (ContainerSourceCollection* self, DataSource* source);
	ContainerSource* (*convert_backlink_to_container) (ContainerSourceCollection* self, SourceBacklink* backlink);
	void (*container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
};

struct _ContainerSourceCollectionPrivate {
	GeeHashSet* attached_collections;
	gchar* backlink_name;
	GeeHashSet* holding_tank;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);

static gpointer container_source_collection_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
#define CONTAINER_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionPrivate))
enum  {
	CONTAINER_SOURCE_COLLECTION_DUMMY_PROPERTY
};
void container_source_collection_detach_all_collections (ContainerSourceCollection* self);
ContainerSourceCollection* container_source_collection_construct (GType object_type, const gchar* backlink_name, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources);
void source_collection_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
void source_collection_relink (SourceCollection* self, DataSource* source);
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self);
void data_collection_freeze_notifications (DataCollection* self);
void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self);
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked);
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked);
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source);
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked);
GeeList* data_source_get_backlinks (DataSource* self, const gchar* name);
gchar* data_object_to_string (DataObject* self);
gchar* source_backlink_to_string (SourceBacklink* self);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source);
gboolean container_source_has_links (ContainerSource* self);
GType tag_get_type (void) G_GNUC_CONST;
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_mark (DataCollection* self, DataObject* object);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection);
gchar* data_collection_to_string (DataCollection* self);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void container_source_collection_finalize (DataCollection* obj);


ContainerSourceCollection* container_source_collection_construct (GType object_type, const gchar* backlink_name, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
	ContainerSourceCollection* self = NULL;
	const gchar* _tmp0_ = NULL;
	GetSourceDatabaseKey _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (backlink_name != NULL, NULL);
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = name;
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = source_key_func;
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1__target = source_key_func_target;
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, _tmp0_, _tmp1_, _tmp1__target);
#line 41 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = backlink_name;
#line 41 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 41 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_free0 (self->priv->backlink_name);
#line 41 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self->priv->backlink_name = _tmp3_;
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return self;
#line 417 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources) {
	ContainerSourceCollection * self;
	SourceBacklink* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	ContainerSource* container = NULL;
	SourceBacklink* _tmp2_ = NULL;
	ContainerSource* _tmp3_ = NULL;
	ContainerSource* _tmp4_ = NULL;
#line 48 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection);
#line 48 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 48 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 50 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = backlink;
#line 50 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = sources;
#line 50 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_backlink_removed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), _tmp0_, _tmp1_);
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = backlink;
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp3_ = container_source_collection_convert_backlink_to_container (self, _tmp2_);
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container = _tmp3_;
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp4_ = container;
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (_tmp4_ != NULL) {
#line 451 "ContainerSourceCollection.c"
		ContainerSource* _tmp5_ = NULL;
		GeeCollection* _tmp6_ = NULL;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp5_ = container;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp6_ = sources;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		container_source_collection_notify_backlink_to_container_removed (self, _tmp5_, _tmp6_);
#line 460 "ContainerSourceCollection.c"
	}
#line 48 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (container);
#line 464 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
	GeeHashSet* _tmp0_ = NULL;
	ContainerSource* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	ContainerSource* _tmp8_ = NULL;
	GeeCollection* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
#line 57 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 57 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 60 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 60 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = container;
#line 60 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (_tmp2_) {
#line 487 "ContainerSourceCollection.c"
		gboolean removed = FALSE;
		GeeHashSet* _tmp3_ = NULL;
		ContainerSource* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		ContainerSource* _tmp7_ = NULL;
#line 61 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp3_ = self->priv->holding_tank;
#line 61 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp4_ = container;
#line 61 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp5_ = gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp4_);
#line 61 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		removed = _tmp5_;
#line 62 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp6_ = removed;
#line 62 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_vala_assert (_tmp6_, "removed");
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp7_ = container;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		source_collection_relink (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SOURCE_COLLECTION, SourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_SOURCE, DataSource));
#line 510 "ContainerSourceCollection.c"
	}
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp8_ = container;
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp9_ = added;
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp10_ = relinked;
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_emit_by_name (self, "container-contents-added", _tmp8_, _tmp9_, _tmp10_);
#line 520 "ContainerSourceCollection.c"
}


void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
#line 57 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 57 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_added (self, container, added, relinked);
#line 529 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
	ContainerSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = container;
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = removed;
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = unlinked;
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_emit_by_name (self, "container-contents-removed", _tmp0_, _tmp1_, _tmp2_);
#line 549 "ContainerSourceCollection.c"
}


void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_removed (self, container, removed, unlinked);
#line 558 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
	ContainerSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = container;
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = added;
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = relinked;
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp3_ = removed;
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp4_ = unlinked;
#line 78 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_emit_by_name (self, "container-contents-altered", _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 586 "ContainerSourceCollection.c"
}


void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_altered (self, container, added, relinked, removed, unlinked);
#line 595 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
	ContainerSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 81 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 81 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 83 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = container;
#line 83 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = sources;
#line 83 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_emit_by_name (self, "backlink-to-container-removed", _tmp0_, _tmp1_);
#line 612 "ContainerSourceCollection.c"
}


void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
#line 81 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 81 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_backlink_to_container_removed (self, container, sources);
#line 621 "ContainerSourceCollection.c"
}


static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return NULL;
#line 630 "ContainerSourceCollection.c"
}


GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->get_containers_holding_source (self, source);
#line 639 "ContainerSourceCollection.c"
}


static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 89 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 89 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return NULL;
#line 648 "ContainerSourceCollection.c"
}


ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 89 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 89 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->convert_backlink_to_container (self, backlink);
#line 657 "ContainerSourceCollection.c"
}


void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self) {
#line 91 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 664 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 677 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			SourceCollection* _tmp6_ = NULL;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp3_) {
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 692 "ContainerSourceCollection.c"
			}
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = _collection_it;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp5_;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = collection;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			data_collection_freeze_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_COLLECTION, DataCollection));
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 706 "ContainerSourceCollection.c"
		}
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 710 "ContainerSourceCollection.c"
	}
}


void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self) {
#line 96 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 718 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 731 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			SourceCollection* _tmp6_ = NULL;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp3_) {
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 746 "ContainerSourceCollection.c"
			}
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = _collection_it;
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp5_;
#line 98 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = collection;
#line 98 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			data_collection_thaw_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_COLLECTION, DataCollection));
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 760 "ContainerSourceCollection.c"
		}
#line 97 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 764 "ContainerSourceCollection.c"
	}
}


GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self) {
	GeeCollection* result = NULL;
	GeeHashSet* _tmp0_ = NULL;
	GeeSet* _tmp1_ = NULL;
	GeeSet* _tmp2_ = NULL;
#line 101 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_abstract_set_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_SET, GeeAbstractSet));
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = _tmp1_;
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 102 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return result;
#line 786 "ContainerSourceCollection.c"
}


void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked) {
	GeeHashSet* _tmp0_ = NULL;
	ContainerSource* _tmp1_ = NULL;
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (unlinked));
#line 106 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 106 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = unlinked;
#line 106 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 803 "ContainerSourceCollection.c"
}


void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked) {
	GeeHashSet* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 109 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 109 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinked));
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = unlinked;
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp1_);
#line 820 "ContainerSourceCollection.c"
}


gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source) {
	gboolean result = FALSE;
	GeeHashSet* _tmp0_ = NULL;
	ContainerSource* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	ContainerSource* _tmp3_ = NULL;
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), FALSE);
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE (source), FALSE);
#line 114 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 114 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = source;
#line 114 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 114 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (!_tmp2_) {
#line 115 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		result = FALSE;
#line 115 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		return result;
#line 846 "ContainerSourceCollection.c"
	}
#line 117 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp3_ = source;
#line 117 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	source_collection_relink (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SOURCE_COLLECTION, SourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_SOURCE, DataSource));
#line 119 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	result = TRUE;
#line 119 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return result;
#line 856 "ContainerSourceCollection.c"
}


static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking) {
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_ = NULL;
#line 122 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 122 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 123 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 125 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 125 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	map = _tmp0_;
#line 873 "ContainerSourceCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = unlinking;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_source_it = _tmp2_;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 886 "ContainerSourceCollection.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			DataSource* source = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			GeeCollection* containers = NULL;
			DataSource* _tmp7_ = NULL;
			GeeCollection* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			GeeCollection* _tmp10_ = NULL;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = _source_it;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp4_) {
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 905 "ContainerSourceCollection.c"
			}
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = _source_it;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			source = (DataSource*) _tmp6_;
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp7_ = source;
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp8_ = container_source_collection_get_containers_holding_source (self, _tmp7_);
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			containers = _tmp8_;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp10_ = containers;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (_tmp10_ == NULL) {
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp9_ = TRUE;
#line 925 "ContainerSourceCollection.c"
			} else {
				GeeCollection* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp11_ = containers;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp12_ = gee_collection_get_size (_tmp11_);
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp13_ = _tmp12_;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp9_ = _tmp13_ == 0;
#line 938 "ContainerSourceCollection.c"
			}
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (_tmp9_) {
#line 131 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (containers);
#line 131 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (source);
#line 131 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				continue;
#line 948 "ContainerSourceCollection.c"
			}
			{
				GeeIterator* _container_it = NULL;
				GeeCollection* _tmp14_ = NULL;
				GeeIterator* _tmp15_ = NULL;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp14_ = containers;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_container_it = _tmp15_;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				while (TRUE) {
#line 962 "ContainerSourceCollection.c"
					GeeIterator* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					ContainerSource* container = NULL;
					GeeIterator* _tmp18_ = NULL;
					gpointer _tmp19_ = NULL;
					GeeHashMultiMap* _tmp20_ = NULL;
					ContainerSource* _tmp21_ = NULL;
					DataSource* _tmp22_ = NULL;
					DataSource* _tmp23_ = NULL;
					ContainerSource* _tmp24_ = NULL;
					SourceBacklink* _tmp25_ = NULL;
					SourceBacklink* _tmp26_ = NULL;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp16_ = _container_it;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp17_ = gee_iterator_next (_tmp16_);
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					if (!_tmp17_) {
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						break;
#line 983 "ContainerSourceCollection.c"
					}
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp18_ = _container_it;
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					container = (ContainerSource*) _tmp19_;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp20_ = map;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp21_ = container;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp22_ = source;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp21_, _tmp22_);
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp23_ = source;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp24_ = container;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp25_ = container_source_get_backlink (_tmp24_);
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp26_ = _tmp25_;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					data_source_set_backlink (_tmp23_, _tmp26_);
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_source_backlink_unref0 (_tmp26_);
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_g_object_unref0 (container);
#line 1013 "ContainerSourceCollection.c"
				}
#line 133 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_container_it);
#line 1017 "ContainerSourceCollection.c"
			}
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (containers);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (source);
#line 1023 "ContainerSourceCollection.c"
		}
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_source_it);
#line 1027 "ContainerSourceCollection.c"
	}
	{
		GeeIterator* _container_it = NULL;
		GeeHashMultiMap* _tmp27_ = NULL;
		GeeSet* _tmp28_ = NULL;
		GeeSet* _tmp29_ = NULL;
		GeeIterator* _tmp30_ = NULL;
		GeeIterator* _tmp31_ = NULL;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp27_ = map;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp28_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp29_ = _tmp28_;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp30_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ITERABLE, GeeIterable));
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp31_ = _tmp30_;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_tmp29_);
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_container_it = _tmp31_;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1052 "ContainerSourceCollection.c"
			GeeIterator* _tmp32_ = NULL;
			gboolean _tmp33_ = FALSE;
			ContainerSource* container = NULL;
			GeeIterator* _tmp34_ = NULL;
			gpointer _tmp35_ = NULL;
			ContainerSource* _tmp36_ = NULL;
			GeeHashMultiMap* _tmp37_ = NULL;
			ContainerSource* _tmp38_ = NULL;
			GeeCollection* _tmp39_ = NULL;
			GeeCollection* _tmp40_ = NULL;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp32_ = _container_it;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp33_ = gee_iterator_next (_tmp32_);
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp33_) {
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1071 "ContainerSourceCollection.c"
			}
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp34_ = _container_it;
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp35_ = gee_iterator_get (_tmp34_);
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			container = (ContainerSource*) _tmp35_;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp36_ = container;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp37_ = map;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp38_ = container;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp39_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp38_);
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp40_ = _tmp39_;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			container_source_break_link_many (_tmp36_, _tmp40_);
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (_tmp40_);
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (container);
#line 1095 "ContainerSourceCollection.c"
		}
#line 139 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_container_it);
#line 1099 "ContainerSourceCollection.c"
	}
#line 142 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 122 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (map);
#line 1105 "ContainerSourceCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 1112 "ContainerSourceCollection.c"
}


static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked) {
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_ = NULL;
#line 145 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 145 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 146 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 148 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 148 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	map = _tmp0_;
#line 1129 "ContainerSourceCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = relinked;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_source_it = _tmp2_;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1142 "ContainerSourceCollection.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			DataSource* source = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			GeeList* backlinks = NULL;
			DataSource* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			GeeList* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			GeeList* _tmp11_ = NULL;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = _source_it;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp4_) {
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1162 "ContainerSourceCollection.c"
			}
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = _source_it;
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			source = (DataSource*) _tmp6_;
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp7_ = source;
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp8_ = self->priv->backlink_name;
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp9_ = data_source_get_backlinks (_tmp7_, _tmp8_);
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			backlinks = _tmp9_;
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp11_ = backlinks;
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (_tmp11_ == NULL) {
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp10_ = TRUE;
#line 1184 "ContainerSourceCollection.c"
			} else {
				GeeList* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp12_ = backlinks;
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp14_ = _tmp13_;
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp10_ = _tmp14_ == 0;
#line 1197 "ContainerSourceCollection.c"
			}
#line 153 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (_tmp10_) {
#line 154 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (backlinks);
#line 154 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (source);
#line 154 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				continue;
#line 1207 "ContainerSourceCollection.c"
			}
			{
				GeeList* _backlink_list = NULL;
				GeeList* _tmp15_ = NULL;
				GeeList* _tmp16_ = NULL;
				gint _backlink_size = 0;
				GeeList* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				gint _backlink_index = 0;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp15_ = backlinks;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_backlink_list = _tmp16_;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp17_ = _backlink_list;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp18_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp19_ = _tmp18_;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_backlink_size = _tmp19_;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_backlink_index = -1;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				while (TRUE) {
#line 1236 "ContainerSourceCollection.c"
					gint _tmp20_ = 0;
					gint _tmp21_ = 0;
					gint _tmp22_ = 0;
					SourceBacklink* backlink = NULL;
					GeeList* _tmp23_ = NULL;
					gint _tmp24_ = 0;
					gpointer _tmp25_ = NULL;
					ContainerSource* container = NULL;
					SourceBacklink* _tmp26_ = NULL;
					ContainerSource* _tmp27_ = NULL;
					ContainerSource* _tmp28_ = NULL;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp20_ = _backlink_index;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_backlink_index = _tmp20_ + 1;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp21_ = _backlink_index;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp22_ = _backlink_size;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					if (!(_tmp21_ < _tmp22_)) {
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						break;
#line 1260 "ContainerSourceCollection.c"
					}
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp23_ = _backlink_list;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp24_ = _backlink_index;
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp25_ = gee_list_get (_tmp23_, _tmp24_);
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					backlink = (SourceBacklink*) _tmp25_;
#line 157 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp26_ = backlink;
#line 157 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp27_ = container_source_collection_convert_backlink_to_container (self, _tmp26_);
#line 157 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					container = _tmp27_;
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_tmp28_ = container;
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					if (_tmp28_ != NULL) {
#line 1280 "ContainerSourceCollection.c"
						GeeHashMultiMap* _tmp29_ = NULL;
						ContainerSource* _tmp30_ = NULL;
						DataSource* _tmp31_ = NULL;
#line 159 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp29_ = map;
#line 159 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp30_ = container;
#line 159 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp31_ = source;
#line 159 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp30_, _tmp31_);
#line 1292 "ContainerSourceCollection.c"
					} else {
						DataSource* _tmp32_ = NULL;
						gchar* _tmp33_ = NULL;
						gchar* _tmp34_ = NULL;
						SourceBacklink* _tmp35_ = NULL;
						gchar* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp32_ = source;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp33_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_DATA_OBJECT, DataObject));
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp34_ = _tmp33_;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp35_ = backlink;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp36_ = source_backlink_to_string (_tmp35_);
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_tmp37_ = _tmp36_;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						g_warning ("ContainerSourceCollection.vala:161: Unable to relink %s to container b" \
"acklink %s", _tmp34_, _tmp37_);
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_g_free0 (_tmp37_);
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
						_g_free0 (_tmp34_);
#line 1318 "ContainerSourceCollection.c"
					}
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_g_object_unref0 (container);
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
					_source_backlink_unref0 (backlink);
#line 1324 "ContainerSourceCollection.c"
				}
#line 156 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_backlink_list);
#line 1328 "ContainerSourceCollection.c"
			}
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (backlinks);
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (source);
#line 1334 "ContainerSourceCollection.c"
		}
#line 151 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_source_it);
#line 1338 "ContainerSourceCollection.c"
	}
	{
		GeeIterator* _container_it = NULL;
		GeeHashMultiMap* _tmp38_ = NULL;
		GeeSet* _tmp39_ = NULL;
		GeeSet* _tmp40_ = NULL;
		GeeIterator* _tmp41_ = NULL;
		GeeIterator* _tmp42_ = NULL;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp38_ = map;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp39_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp40_ = _tmp39_;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp41_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ITERABLE, GeeIterable));
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp42_ = _tmp41_;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_tmp40_);
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_container_it = _tmp42_;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1363 "ContainerSourceCollection.c"
			GeeIterator* _tmp43_ = NULL;
			gboolean _tmp44_ = FALSE;
			ContainerSource* container = NULL;
			GeeIterator* _tmp45_ = NULL;
			gpointer _tmp46_ = NULL;
			ContainerSource* _tmp47_ = NULL;
			GeeHashMultiMap* _tmp48_ = NULL;
			ContainerSource* _tmp49_ = NULL;
			GeeCollection* _tmp50_ = NULL;
			GeeCollection* _tmp51_ = NULL;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp43_ = _container_it;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp44_ = gee_iterator_next (_tmp43_);
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp44_) {
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1382 "ContainerSourceCollection.c"
			}
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp45_ = _container_it;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp46_ = gee_iterator_get (_tmp45_);
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			container = (ContainerSource*) _tmp46_;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp47_ = container;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp48_ = map;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp49_ = container;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp50_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp49_);
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp51_ = _tmp50_;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			container_source_establish_link_many (_tmp47_, _tmp51_);
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (_tmp51_);
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (container);
#line 1406 "ContainerSourceCollection.c"
		}
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_container_it);
#line 1410 "ContainerSourceCollection.c"
	}
#line 170 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 145 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (map);
#line 1416 "ContainerSourceCollection.c"
}


static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source) {
	GeeIterator* iter = NULL;
	GeeHashSet* _tmp0_ = NULL;
	GeeIterator* _tmp1_ = NULL;
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 174 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 174 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 174 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	iter = _tmp1_;
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	while (TRUE) {
#line 1436 "ContainerSourceCollection.c"
		GeeIterator* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		ContainerSource* container = NULL;
		GeeIterator* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		ContainerSource* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp2_ = iter;
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp3_ = gee_iterator_next (_tmp2_);
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		if (!_tmp3_) {
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			break;
#line 1453 "ContainerSourceCollection.c"
		}
#line 176 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp4_ = iter;
#line 176 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp5_ = gee_iterator_get (_tmp4_);
#line 176 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		container = (ContainerSource*) _tmp5_;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp7_ = container;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp8_ = container_source_has_links (_tmp7_);
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		if (!_tmp8_) {
#line 1467 "ContainerSourceCollection.c"
			ContainerSource* _tmp9_ = NULL;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp9_ = container;
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, TYPE_TAG);
#line 1473 "ContainerSourceCollection.c"
		} else {
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = FALSE;
#line 1477 "ContainerSourceCollection.c"
		}
#line 180 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		if (_tmp6_) {
#line 1481 "ContainerSourceCollection.c"
			GeeIterator* _tmp10_ = NULL;
			ContainerSource* _tmp11_ = NULL;
#line 181 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp10_ = iter;
#line 181 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			gee_iterator_remove (_tmp10_);
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp11_ = container;
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			data_source_destroy_orphan (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_DATA_SOURCE, DataSource), TRUE);
#line 1492 "ContainerSourceCollection.c"
		}
#line 175 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (container);
#line 1496 "ContainerSourceCollection.c"
	}
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (iter);
#line 1500 "ContainerSourceCollection.c"
}


static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source) {
	ContainerSourceCollection * self;
	DataSource* _tmp10_ = NULL;
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection);
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1511 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1524 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			SourceCollection* _tmp6_ = NULL;
			DataSource* _tmp7_ = NULL;
			SourceBacklink* _tmp8_ = NULL;
			SourceBacklink* _tmp9_ = NULL;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp3_) {
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1542 "ContainerSourceCollection.c"
			}
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = _collection_it;
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp5_;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = collection;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp7_ = source;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp8_ = container_source_get_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_CONTAINER_SOURCE, ContainerSource));
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp9_ = _tmp8_;
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			source_collection_remove_backlink (_tmp6_, _tmp9_);
#line 189 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_source_backlink_unref0 (_tmp9_);
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1564 "ContainerSourceCollection.c"
		}
#line 188 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1568 "ContainerSourceCollection.c"
	}
#line 192 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp10_ = source;
#line 192 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), _tmp10_);
#line 1574 "ContainerSourceCollection.c"
}


void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container) {
	ContainerSource* _tmp21_ = NULL;
	Marker* _tmp22_ = NULL;
	Marker* _tmp23_ = NULL;
#line 199 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 199 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1586 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1599 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			SourceCollection* _tmp6_ = NULL;
			ContainerSource* _tmp7_ = NULL;
			SourceBacklink* _tmp8_ = NULL;
			SourceBacklink* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp3_) {
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1619 "ContainerSourceCollection.c"
			}
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = _collection_it;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp5_;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = collection;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp7_ = container;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp8_ = container_source_get_backlink (_tmp7_);
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp9_ = _tmp8_;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp10_ = source_collection_has_backlink (_tmp6_, _tmp9_);
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp11_ = _tmp10_;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_source_backlink_unref0 (_tmp9_);
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (_tmp11_) {
#line 1643 "ContainerSourceCollection.c"
				ContainerSource* _tmp12_ = NULL;
				Marker* _tmp13_ = NULL;
				Marker* _tmp14_ = NULL;
				GeeCollection* _tmp15_ = NULL;
				GeeCollection* _tmp16_ = NULL;
				gboolean added = FALSE;
				GeeHashSet* _tmp17_ = NULL;
				ContainerSource* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp12_ = container;
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp13_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_OBJECT, DataObject));
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp14_ = _tmp13_;
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp15_ = source_collection_unlink_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp14_, NULL, NULL);
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp16_ = _tmp15_;
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_tmp16_);
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp17_ = self->priv->holding_tank;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp18_ = container;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp19_ = gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp18_);
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				added = _tmp19_;
#line 204 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_tmp20_ = added;
#line 204 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_vala_assert (_tmp20_, "added");
#line 205 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_data_collection_unref0 (collection);
#line 205 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_collection_it);
#line 205 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				return;
#line 1686 "ContainerSourceCollection.c"
			}
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1690 "ContainerSourceCollection.c"
		}
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1694 "ContainerSourceCollection.c"
	}
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp21_ = container;
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp22_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_DATA_OBJECT, DataObject));
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp23_ = _tmp22_;
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp23_, TRUE, NULL, NULL, NULL);
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (_tmp23_);
#line 1706 "ContainerSourceCollection.c"
}


static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self) {
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_sources_unlinking ((ContainerSourceCollection*) self, unlinking);
#line 1713 "ContainerSourceCollection.c"
}


static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self) {
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_sources_relinked ((ContainerSourceCollection*) self, relinked);
#line 1720 "ContainerSourceCollection.c"
}


static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 222 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_source_destroyed ((ContainerSourceCollection*) self, source);
#line 1727 "ContainerSourceCollection.c"
}


static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_source_destroyed ((ContainerSourceCollection*) self, source);
#line 1734 "ContainerSourceCollection.c"
}


void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection) {
	GeeHashSet* _tmp0_ = NULL;
	SourceCollection* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GeeHashSet* _tmp8_ = NULL;
	SourceCollection* _tmp9_ = NULL;
	SourceCollection* _tmp10_ = NULL;
	SourceCollection* _tmp11_ = NULL;
	SourceCollection* _tmp12_ = NULL;
	SourceCollection* _tmp13_ = NULL;
#line 212 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 212 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->attached_collections;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = collection;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp2_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (_tmp2_) {
#line 1760 "ContainerSourceCollection.c"
		SourceCollection* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp3_ = collection;
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp4_ = data_collection_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_COLLECTION, DataCollection));
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp5_ = _tmp4_;
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp6_ = data_collection_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp7_ = _tmp6_;
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		g_warning ("ContainerSourceCollection.vala:214: attempted to multiple-attach '%s' " \
"to '%s'", _tmp5_, _tmp7_);
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_free0 (_tmp7_);
#line 214 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_free0 (_tmp5_);
#line 215 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		return;
#line 1784 "ContainerSourceCollection.c"
	}
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp8_ = self->priv->attached_collections;
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp9_ = collection;
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_);
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp10_ = collection;
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_connect (_tmp10_, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp11_ = collection;
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_connect (_tmp11_, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 222 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp12_ = collection;
#line 222 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_connect (_tmp12_, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp13_ = collection;
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_connect (_tmp13_, "unlinked-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 1808 "ContainerSourceCollection.c"
}


void container_source_collection_detach_all_collections (ContainerSourceCollection* self) {
	GeeHashSet* _tmp14_ = NULL;
#line 226 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1816 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1829 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			SourceCollection* _tmp6_ = NULL;
			guint _tmp7_ = 0U;
			SourceCollection* _tmp8_ = NULL;
			guint _tmp9_ = 0U;
			SourceCollection* _tmp10_ = NULL;
			guint _tmp11_ = 0U;
			SourceCollection* _tmp12_ = NULL;
			guint _tmp13_ = 0U;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			if (!_tmp3_) {
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
				break;
#line 1851 "ContainerSourceCollection.c"
			}
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp4_ = _collection_it;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp5_;
#line 228 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp6_ = collection;
#line 228 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp7_, NULL, FALSE);
#line 228 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp8_ = collection;
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp9_, NULL, FALSE);
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 230 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp10_ = collection;
#line 230 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp11_, NULL, FALSE);
#line 230 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_tmp12_ = collection;
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp13_, NULL, FALSE);
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1885 "ContainerSourceCollection.c"
		}
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1889 "ContainerSourceCollection.c"
	}
#line 234 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp14_ = self->priv->attached_collections;
#line 234 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1895 "ContainerSourceCollection.c"
}


static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 1904 "ContainerSourceCollection.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 4);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 1923 "ContainerSourceCollection.c"
	} else {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 1929 "ContainerSourceCollection.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), data2);
#line 1935 "ContainerSourceCollection.c"
}


static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
#line 24 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 24 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 1944 "ContainerSourceCollection.c"
}


static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1955 "ContainerSourceCollection.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 6);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 1974 "ContainerSourceCollection.c"
	} else {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 1980 "ContainerSourceCollection.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_object (param_values + 4), g_value_get_boolean (param_values + 5), data2);
#line 1986 "ContainerSourceCollection.c"
}


static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
#line 33 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 33 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 1995 "ContainerSourceCollection.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 3);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 2014 "ContainerSourceCollection.c"
	} else {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 2020 "ContainerSourceCollection.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 2026 "ContainerSourceCollection.c"
}


static void container_source_collection_class_init (ContainerSourceCollectionClass * klass) {
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((DataCollectionClass *) klass)->finalize = container_source_collection_finalize;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_type_class_add_private (klass, sizeof (ContainerSourceCollectionPrivate));
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((SourceCollectionClass *) klass)->notify_backlink_removed = container_source_collection_real_notify_backlink_removed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_added = container_source_collection_real_notify_container_contents_added;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_removed = container_source_collection_real_notify_container_contents_removed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_altered = container_source_collection_real_notify_container_contents_altered;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_backlink_to_container_removed = container_source_collection_real_notify_backlink_to_container_removed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->get_containers_holding_source = container_source_collection_real_get_containers_holding_source;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->convert_backlink_to_container = container_source_collection_real_convert_backlink_to_container;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((SourceCollectionClass *) klass)->notify_item_destroyed = container_source_collection_real_notify_item_destroyed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_added = container_source_collection_real_container_contents_added;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->backlink_to_container_removed = container_source_collection_real_backlink_to_container_removed;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_new ("container_contents_added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_new ("container_contents_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_new ("container_contents_altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN, G_TYPE_NONE, 5, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	g_signal_new ("backlink_to_container_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, backlink_to_container_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
#line 2069 "ContainerSourceCollection.c"
}


static void container_source_collection_instance_init (ContainerSourceCollection * self) {
	GeeHashSet* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self->priv = CONTAINER_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 16 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 16 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self->priv->attached_collections = _tmp0_;
#line 18 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 18 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self->priv->holding_tank = _tmp1_;
#line 2086 "ContainerSourceCollection.c"
}


static void container_source_collection_finalize (DataCollection* obj) {
	ContainerSourceCollection * self;
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection);
#line 45 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	container_source_collection_detach_all_collections (self);
#line 16 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (self->priv->attached_collections);
#line 17 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_free0 (self->priv->backlink_name);
#line 18 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (self->priv->holding_tank);
#line 15 "/builddir/build/BUILD/shotwell-0.20.2/src/core/ContainerSourceCollection.vala"
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
#line 2104 "ContainerSourceCollection.c"
}


GType container_source_collection_get_type (void) {
	static volatile gsize container_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
		GType container_source_collection_type_id;
		container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&container_source_collection_type_id__volatile, container_source_collection_type_id);
	}
	return container_source_collection_type_id__volatile;
}



