/* MetadataWriter.c generated by valac 0.26.1, the Vala compiler
 * generated from MetadataWriter.vala, do not modify */

/* Copyright 2010-2014 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* MetadataWriter tracks LibraryPhotos for alterations to their metadata and commits those changes*/
/* in a timely manner to their backing files.  Because only the MetadataWriter knows when the*/
/* metadata has been properly committed, it is also responsible for updating the metadata-dirty*/
/* flag in Photo.  Thus, MetadataWriter should *always* be running, even if the user has turned off*/
/* the feature, so if they turn it on MetadataWriter can properly go out and update the backing*/
/* files.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <time.h>


#define TYPE_METADATA_WRITER (metadata_writer_get_type ())
#define METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_WRITER, MetadataWriter))
#define METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_WRITER, MetadataWriterClass))
#define IS_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_WRITER))
#define IS_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_WRITER))
#define METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_WRITER, MetadataWriterClass))

typedef struct _MetadataWriter MetadataWriter;
typedef struct _MetadataWriterClass MetadataWriterClass;
typedef struct _MetadataWriterPrivate MetadataWriterPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define METADATA_WRITER_TYPE_COMMIT_JOB (metadata_writer_commit_job_get_type ())
#define METADATA_WRITER_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob))
#define METADATA_WRITER_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))
#define METADATA_WRITER_IS_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_IS_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_COMMIT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))

typedef struct _MetadataWriterCommitJob MetadataWriterCommitJob;
typedef struct _MetadataWriterCommitJobClass MetadataWriterCommitJobClass;

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _timed_queue_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _MetadataWriterCommitJobPrivate MetadataWriterCommitJobPrivate;

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_RATING (rating_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MetadataWriter {
	GObject parent_instance;
	MetadataWriterPrivate * priv;
};

struct _MetadataWriterClass {
	GObjectClass parent_class;
};

struct _MetadataWriterPrivate {
	Workers* workers;
	gboolean enabled;
	HashTimedQueue* dirty;
	GeeHashMap* pending;
	GeeHashSet* interested_photo_details;
	LibraryPhoto* ignore_photo_alteration;
	guint outstanding_total;
	guint outstanding_completed;
	gboolean closed;
	gint pause_count;
	GeeHashSet* importing_photos;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _MetadataWriterCommitJob {
	BackgroundJob parent_instance;
	MetadataWriterCommitJobPrivate * priv;
	LibraryPhoto* photo;
	GeeSet* current_keywords;
	PhotoReimportMasterState* reimport_master_state;
	PhotoReimportEditableState* reimport_editable_state;
	GError* err;
};

struct _MetadataWriterCommitJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


static gpointer metadata_writer_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
extern TagSourceCollection* tag_global;
static MetadataWriter* metadata_writer_instance;
static MetadataWriter* metadata_writer_instance = NULL;
static gpointer metadata_writer_commit_job_parent_class = NULL;

GType metadata_writer_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType photo_source_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType library_photo_get_type (void) G_GNUC_CONST;
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
static GType metadata_writer_commit_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define METADATA_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_WRITER, MetadataWriterPrivate))
enum  {
	METADATA_WRITER_DUMMY_PROPERTY
};
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
static void metadata_writer_on_config_changed (MetadataWriter* self);
static void _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed (ConfigurationFacade* _sender, gpointer self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed);
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self);
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items);
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void metadata_writer_on_collection_frozen (MetadataWriter* self);
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self);
static void metadata_writer_on_collection_thawed (MetadataWriter* self);
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed);
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map);
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking);
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self);
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources);
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self);
gpointer application_ref (gpointer instance);
void application_unref (gpointer instance);
GParamSpec* param_spec_application (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_application (GValue* value, gpointer v_object);
void value_take_application (GValue* value, gpointer v_object);
gpointer value_get_application (const GValue* value);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
static void metadata_writer_on_application_exiting (MetadataWriter* self);
static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self);
gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_library_monitor_pool (GValue* value, gpointer v_object);
void value_take_library_monitor_pool (GValue* value, gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
LibraryMonitorPool* library_monitor_pool_get_instance (void);
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_monitor_installed (MetadataWriter* self, LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender, LibraryMonitor* monitor, gpointer self);
static void metadata_writer_on_monitor_destroyed (MetadataWriter* self, LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender, LibraryMonitor* monitor, gpointer self);
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
#define METADATA_WRITER_COMMIT_DELAY_MSEC ((guint) 3000)
#define METADATA_WRITER_COMMIT_SPACING_MSEC ((guint) 50)
static MetadataWriter* metadata_writer_new (void);
static MetadataWriter* metadata_writer_construct (GType object_type);
static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo);
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self, guint msec);
void metadata_writer_pause (MetadataWriter* self);
gboolean configuration_facade_get_commit_metadata_to_masters (ConfigurationFacade* self);
void metadata_writer_force_rescan (MetadataWriter* self);
void metadata_writer_init (void);
void metadata_writer_terminate (void);
void metadata_writer_close (MetadataWriter* self);
MetadataWriter* metadata_writer_get_instance (void);
static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const gchar* reason);
GeeCollection* data_collection_get_all (DataCollection* self);
void timed_queue_pause (TimedQueue* self);
void metadata_writer_unpause (MetadataWriter* self);
void timed_queue_unpause (TimedQueue* self);
static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait);
static void metadata_writer_on_discovery_completed (MetadataWriter* self);
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self);
static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self, const gchar* subject);
static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const gchar* reason, gboolean already_marked);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* tag_get_sources (Tag* self);
gchar* data_object_to_string (DataObject* self);
static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report);
gboolean photo_is_master_metadata_dirty (Photo* self);
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
void transaction_controller_begin (TransactionController* self);
GQuark database_error_quark (void);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void transaction_controller_commit (TransactionController* self);
void app_window_database_error (GError* err);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
void timed_queue_clear (TimedQueue* self);
void background_job_cancel (BackgroundJob* self);
void workers_wait_for_empty_queue (Workers* self);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_remove_first (TimedQueue* self, gconstpointer item);
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
gchar* data_object_get_name (DataObject* self);
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
void workers_enqueue (Workers* self, BackgroundJob* job);
static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
enum  {
	METADATA_WRITER_COMMIT_JOB_DUMMY_PROPERTY
};
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self);
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
gpointer abstract_semaphore_ref (gpointer instance);
void abstract_semaphore_unref (gpointer instance);
GParamSpec* param_spec_abstract_semaphore (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_abstract_semaphore (GValue* value, gpointer v_object);
void value_take_abstract_semaphore (GValue* value, gpointer v_object);
gpointer value_get_abstract_semaphore (const GValue* value);
GType abstract_semaphore_get_type (void) G_GNUC_CONST;
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target, AbstractSemaphore* completion_semaphore);
static void metadata_writer_commit_job_real_execute (BackgroundJob* base);
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error);
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error);
gboolean photo_has_editable (Photo* self);
GType photo_file_format_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_get_master_file_format (Photo* self);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata, gboolean skip_orientation);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
GFile* media_source_get_master_file (MediaSource* self);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void library_monitor_unblacklist_file (GFile* file);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
GFile* photo_get_editable_file (Photo* self);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
gchar* media_source_get_title (MediaSource* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment);
GType rating_get_type (void) G_GNUC_CONST;
Rating media_source_get_rating (MediaSource* self);
Rating photo_metadata_get_rating (PhotoMetadata* self);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
time_t media_source_get_exposure_time (MediaSource* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
Tag* tag_for_path (const gchar* name);
gchar* tag_get_user_visible_name (Tag* self);
gboolean equal_sets (GeeSet* a, GeeSet* b);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_get_orientation (Photo* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
static void metadata_writer_commit_job_finalize (BackgroundJob* obj);
static void metadata_writer_finalize (GObject* obj);

static const gchar* METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS[4] = {"name", "comment", "rating", "exposure-time"};

static void _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed (ConfigurationFacade* _sender, gpointer self) {
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_config_changed ((MetadataWriter*) self);
#line 822 "MetadataWriter.c"
}


static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 215 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_importing_photos ((MetadataWriter*) self, media);
#line 829 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_photos_imported ((MetadataWriter*) self, media);
#line 836 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self) {
#line 217 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_photos_added_removed ((MetadataWriter*) self, added, removed);
#line 843 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_photos_altered ((MetadataWriter*) self, items);
#line 850 "MetadataWriter.c"
}


static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self) {
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_collection_frozen ((MetadataWriter*) self);
#line 857 "MetadataWriter.c"
}


static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_collection_thawed ((MetadataWriter*) self);
#line 864 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self) {
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_photos_destroyed ((MetadataWriter*) self, destroyed);
#line 871 "MetadataWriter.c"
}


static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_tags_altered ((MetadataWriter*) self, items);
#line 878 "MetadataWriter.c"
}


static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self) {
#line 224 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_tag_contents_altered ((MetadataWriter*) self, container, added, relinked, removed, unlinked);
#line 885 "MetadataWriter.c"
}


static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self) {
#line 225 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_tag_backlink_removed ((MetadataWriter*) self, container, sources);
#line 892 "MetadataWriter.c"
}


static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self) {
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_application_exiting ((MetadataWriter*) self);
#line 899 "MetadataWriter.c"
}


static void _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender, LibraryMonitor* monitor, gpointer self) {
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_monitor_installed ((MetadataWriter*) self, monitor);
#line 906 "MetadataWriter.c"
}


static void _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender, LibraryMonitor* monitor, gpointer self) {
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_monitor_destroyed ((MetadataWriter*) self, monitor);
#line 913 "MetadataWriter.c"
}


static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self) {
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_photo_dequeued ((MetadataWriter*) self, (LibraryPhoto*) item);
#line 920 "MetadataWriter.c"
}


static MetadataWriter* metadata_writer_construct (GType object_type) {
	MetadataWriter * self = NULL;
	HashTimedQueue* _tmp0_ = NULL;
	HashTimedQueue* _tmp1_ = NULL;
	ConfigFacade* _tmp5_ = NULL;
	ConfigFacade* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	ConfigFacade* _tmp8_ = NULL;
	ConfigFacade* _tmp9_ = NULL;
	LibraryPhotoSourceCollection* _tmp10_ = NULL;
	LibraryPhotoSourceCollection* _tmp11_ = NULL;
	LibraryPhotoSourceCollection* _tmp12_ = NULL;
	LibraryPhotoSourceCollection* _tmp13_ = NULL;
	LibraryPhotoSourceCollection* _tmp14_ = NULL;
	LibraryPhotoSourceCollection* _tmp15_ = NULL;
	LibraryPhotoSourceCollection* _tmp16_ = NULL;
	TagSourceCollection* _tmp17_ = NULL;
	TagSourceCollection* _tmp18_ = NULL;
	TagSourceCollection* _tmp19_ = NULL;
	TagSourceCollection* _tmp20_ = NULL;
	TagSourceCollection* _tmp21_ = NULL;
	Application* _tmp22_ = NULL;
	Application* _tmp23_ = NULL;
	LibraryMonitorPool* _tmp24_ = NULL;
	LibraryMonitorPool* _tmp25_ = NULL;
	LibraryMonitorPool* _tmp26_ = NULL;
	LibraryMonitorPool* _tmp27_ = NULL;
#line 172 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self = (MetadataWriter*) g_object_new (object_type, NULL);
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = hash_timed_queue_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_COMMIT_DELAY_MSEC, _metadata_writer_on_photo_dequeued_dequeued_callback, self, NULL, NULL, NULL, NULL, NULL, NULL, G_PRIORITY_DEFAULT);
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 173 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->dirty = _tmp0_;
#line 174 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 174 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	timed_queue_set_dequeue_spacing_msec (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TIMED_QUEUE, TimedQueue), METADATA_WRITER_COMMIT_SPACING_MSEC);
#line 179 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 965 "MetadataWriter.c"
	{
		const gchar** detail_collection = NULL;
		gint detail_collection_length1 = 0;
		gint _detail_collection_size_ = 0;
		gint detail_it = 0;
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		detail_collection = METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS;
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		detail_collection_length1 = G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS);
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		for (detail_it = 0; detail_it < G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS); detail_it = detail_it + 1) {
#line 977 "MetadataWriter.c"
			gchar* _tmp2_ = NULL;
			gchar* detail = NULL;
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp2_ = g_strdup (detail_collection[detail_it]);
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			detail = _tmp2_;
#line 984 "MetadataWriter.c"
			{
				GeeHashSet* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp3_ = self->priv->interested_photo_details;
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp4_ = detail;
#line 183 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp4_);
#line 182 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_free0 (detail);
#line 996 "MetadataWriter.c"
			}
		}
	}
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = config_facade_get_instance ();
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = _tmp5_;
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = configuration_facade_get_commit_metadata_to_masters (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->enabled = _tmp7_;
#line 186 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp6_);
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp8_ = config_facade_get_instance ();
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = _tmp8_;
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), "commit-metadata-to-masters-changed", (GCallback) _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed, self, 0);
#line 187 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp9_);
#line 190 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_force_rescan (self);
#line 192 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp10_ = library_photo_global;
#line 192 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "media-import-starting", (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self, 0);
#line 193 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 193 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "media-import-completed", (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self, 0);
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp12_ = library_photo_global;
#line 194 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_COLLECTION, DataCollection), "contents-altered", (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self, 0);
#line 195 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 195 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_COLLECTION, DataCollection), "items-altered", (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self, 0);
#line 196 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp14_ = library_photo_global;
#line 196 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_DATA_COLLECTION, DataCollection), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 197 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_DATA_COLLECTION, DataCollection), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 198 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp16_ = library_photo_global;
#line 198 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_SOURCE_COLLECTION, SourceCollection), "items-destroyed", (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self, 0);
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 200 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_DATA_COLLECTION, DataCollection), "items-altered", (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self, 0);
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp18_ = tag_global;
#line 201 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection), "container-contents-altered", (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 202 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection), "backlink-to-container-removed", (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self, 0);
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp20_ = tag_global;
#line 203 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_DATA_COLLECTION, DataCollection), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 204 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp21_ = tag_global;
#line 204 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_DATA_COLLECTION, DataCollection), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 206 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp22_ = application_get_instance ();
#line 206 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp23_ = _tmp22_;
#line 206 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp23_, "exiting", (GCallback) _metadata_writer_on_application_exiting_application_exiting, self, 0);
#line 206 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_application_unref0 (_tmp23_);
#line 208 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp24_ = library_monitor_pool_get_instance ();
#line 208 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp25_ = _tmp24_;
#line 208 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp25_, "monitor-installed", (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self, 0);
#line 208 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp25_);
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp26_ = library_monitor_pool_get_instance ();
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp27_ = _tmp26_;
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp27_, "monitor-destroyed", (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self, 0);
#line 209 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp27_);
#line 172 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return self;
#line 1094 "MetadataWriter.c"
}


static MetadataWriter* metadata_writer_new (void) {
#line 172 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return metadata_writer_construct (TYPE_METADATA_WRITER);
#line 1101 "MetadataWriter.c"
}


void metadata_writer_init (void) {
	MetadataWriter* _tmp0_ = NULL;
#line 236 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_new ();
#line 236 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 236 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_instance = _tmp0_;
#line 1113 "MetadataWriter.c"
}


void metadata_writer_terminate (void) {
	MetadataWriter* _tmp0_ = NULL;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 240 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_ != NULL) {
#line 1123 "MetadataWriter.c"
		MetadataWriter* _tmp1_ = NULL;
#line 241 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = metadata_writer_instance;
#line 241 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_close (_tmp1_);
#line 1129 "MetadataWriter.c"
	}
#line 243 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 243 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_instance = NULL;
#line 1135 "MetadataWriter.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return self ? g_object_ref (self) : NULL;
#line 1142 "MetadataWriter.c"
}


MetadataWriter* metadata_writer_get_instance (void) {
	MetadataWriter* result = NULL;
	MetadataWriter* _tmp0_ = NULL;
	MetadataWriter* _tmp1_ = NULL;
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	result = _tmp1_;
#line 247 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return result;
#line 1158 "MetadataWriter.c"
}


void metadata_writer_force_rescan (MetadataWriter* self) {
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
#line 251 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 252 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = library_photo_global;
#line 252 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_COLLECTION, DataCollection));
#line 252 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 252 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_schedule_if_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable), "force rescan");
#line 252 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp2_);
#line 1178 "MetadataWriter.c"
}


void metadata_writer_pause (MetadataWriter* self) {
	gint _tmp0_ = 0;
	HashTimedQueue* _tmp1_ = NULL;
#line 255 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pause_count;
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->pause_count = _tmp0_ + 1;
#line 256 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_ != 0) {
#line 257 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 1195 "MetadataWriter.c"
	}
#line 259 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 259 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	timed_queue_pause (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TIMED_QUEUE, TimedQueue));
#line 261 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_emit_by_name (self, "progress", (guint) 0, (guint) 0);
#line 1203 "MetadataWriter.c"
}


void metadata_writer_unpause (MetadataWriter* self) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	HashTimedQueue* _tmp4_ = NULL;
#line 264 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = self->priv->pause_count;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp1_ == 0) {
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 1219 "MetadataWriter.c"
	} else {
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = self->priv->pause_count;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->pause_count = _tmp2_ - 1;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = self->priv->pause_count;
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = _tmp3_ != 0;
#line 1231 "MetadataWriter.c"
	}
#line 265 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 266 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 1237 "MetadataWriter.c"
	}
#line 268 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = self->priv->dirty;
#line 268 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	timed_queue_unpause (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_TIMED_QUEUE, TimedQueue));
#line 1243 "MetadataWriter.c"
}


void metadata_writer_close (MetadataWriter* self) {
	gboolean _tmp0_ = FALSE;
#line 271 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 272 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->closed;
#line 272 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 273 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 1257 "MetadataWriter.c"
	}
#line 275 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_cancel_all (self, TRUE);
#line 277 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->closed = TRUE;
#line 1263 "MetadataWriter.c"
}


static void metadata_writer_on_config_changed (MetadataWriter* self) {
	gboolean value = FALSE;
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 280 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = config_facade_get_instance ();
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = configuration_facade_get_commit_metadata_to_masters (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = _tmp2_;
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 281 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	value = _tmp3_;
#line 283 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = self->priv->enabled;
#line 283 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = value;
#line 283 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp4_ == _tmp5_) {
#line 284 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 1299 "MetadataWriter.c"
	}
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = value;
#line 286 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->enabled = _tmp6_;
#line 287 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = self->priv->enabled;
#line 287 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp7_) {
#line 288 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_force_rescan (self);
#line 1311 "MetadataWriter.c"
	} else {
#line 290 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_cancel_all (self, FALSE);
#line 1315 "MetadataWriter.c"
	}
}


static void metadata_writer_on_application_exiting (MetadataWriter* self) {
#line 293 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 294 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_close (self);
#line 1325 "MetadataWriter.c"
}


static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self) {
#line 298 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_discovery_completed ((MetadataWriter*) self);
#line 1332 "MetadataWriter.c"
}


static void metadata_writer_on_monitor_installed (MetadataWriter* self, LibraryMonitor* monitor) {
	LibraryMonitor* _tmp0_ = NULL;
#line 297 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 297 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (monitor));
#line 298 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = monitor;
#line 298 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), "discovery-completed", (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self, 0);
#line 1346 "MetadataWriter.c"
}


static void metadata_writer_on_monitor_destroyed (MetadataWriter* self, LibraryMonitor* monitor) {
	LibraryMonitor* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 301 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 301 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (monitor));
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = monitor;
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("discovery-completed", TYPE_DIRECTORY_MONITOR, &_tmp1_, NULL, FALSE);
#line 302 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self);
#line 1363 "MetadataWriter.c"
}


static void metadata_writer_on_discovery_completed (MetadataWriter* self) {
#line 305 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 306 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1372 "MetadataWriter.c"
}


static void metadata_writer_on_collection_frozen (MetadataWriter* self) {
#line 309 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 310 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 1381 "MetadataWriter.c"
}


static void metadata_writer_on_collection_thawed (MetadataWriter* self) {
#line 313 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 314 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1390 "MetadataWriter.c"
}


static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources) {
	GeeHashSet* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 317 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 317 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 318 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 318 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = media_sources;
#line 318 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1407 "MetadataWriter.c"
}


static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources) {
	GeeHashSet* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 321 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 322 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 322 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = media_sources;
#line 322 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	gee_collection_remove_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1424 "MetadataWriter.c"
}


static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed) {
	gboolean _tmp0_ = FALSE;
	GeeIterable* _tmp1_ = NULL;
	GeeIterable* _tmp4_ = NULL;
#line 325 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 325 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 325 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = added;
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp1_ != NULL) {
#line 1442 "MetadataWriter.c"
		gboolean _tmp2_ = FALSE;
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = self->priv->enabled;
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = _tmp2_;
#line 1448 "MetadataWriter.c"
	} else {
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 1452 "MetadataWriter.c"
	}
#line 328 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 1456 "MetadataWriter.c"
		GeeIterable* _tmp3_ = NULL;
#line 329 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = added;
#line 329 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_schedule_if_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable), "added to LibraryPhoto.global");
#line 1462 "MetadataWriter.c"
	}
#line 332 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = removed;
#line 332 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp4_ != NULL) {
#line 1468 "MetadataWriter.c"
		gboolean cancelled = FALSE;
		gboolean _tmp15_ = FALSE;
#line 333 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		cancelled = FALSE;
#line 1473 "MetadataWriter.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterable* _tmp5_ = NULL;
			GeeIterator* _tmp6_ = NULL;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp5_ = removed;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = gee_iterable_iterator (_tmp5_);
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_object_it = _tmp6_;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			while (TRUE) {
#line 1486 "MetadataWriter.c"
				GeeIterator* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				DataObject* object = NULL;
				GeeIterator* _tmp9_ = NULL;
				gpointer _tmp10_ = NULL;
				gboolean _tmp11_ = FALSE;
				DataObject* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp7_ = _object_it;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp8_ = gee_iterator_next (_tmp7_);
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (!_tmp8_) {
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					break;
#line 1503 "MetadataWriter.c"
				}
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp9_ = _object_it;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				object = (DataObject*) _tmp10_;
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp12_ = object;
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp13_ = metadata_writer_cancel_job (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp13_) {
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp11_ = TRUE;
#line 1519 "MetadataWriter.c"
				} else {
					gboolean _tmp14_ = FALSE;
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp14_ = cancelled;
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp11_ = _tmp14_;
#line 1526 "MetadataWriter.c"
				}
#line 335 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				cancelled = _tmp11_;
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 1532 "MetadataWriter.c"
			}
#line 334 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_object_it);
#line 1536 "MetadataWriter.c"
		}
#line 337 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp15_ = cancelled;
#line 337 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (_tmp15_) {
#line 1542 "MetadataWriter.c"
			guint _tmp16_ = 0U;
			guint _tmp17_ = 0U;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp16_ = self->priv->outstanding_completed;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp17_ = self->priv->outstanding_total;
#line 338 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_signal_emit_by_name (self, "progress", _tmp16_, _tmp17_);
#line 1551 "MetadataWriter.c"
		}
	}
}


static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items) {
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp39_ = NULL;
#line 342 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 342 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 343 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	photos = NULL;
#line 1566 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = items;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp3_);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_object_it = _tmp5_;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 1593 "MetadataWriter.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			DataObject* object = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_ = NULL;
			LibraryPhoto* _tmp11_ = NULL;
			LibraryPhoto* _tmp12_ = NULL;
			LibraryPhoto* _tmp13_ = NULL;
			Alteration* alteration = NULL;
			GeeMap* _tmp14_ = NULL;
			DataObject* _tmp15_ = NULL;
			gpointer _tmp16_ = NULL;
			Alteration* _tmp17_ = NULL;
			gboolean _tmp18_ = FALSE;
			GeeCollection* details = NULL;
			Alteration* _tmp23_ = NULL;
			GeeCollection* _tmp24_ = NULL;
			GeeCollection* _tmp25_ = NULL;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp7_) {
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 1622 "MetadataWriter.c"
			}
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = _object_it;
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			object = (DataObject*) _tmp9_;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp10_ = object;
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 345 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = _tmp11_;
#line 349 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp12_ = photo;
#line 349 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp13_ = self->priv->ignore_photo_alteration;
#line 349 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp12_ == _tmp13_) {
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 350 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 1648 "MetadataWriter.c"
			}
#line 352 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp14_ = items;
#line 352 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp15_ = object;
#line 352 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp16_ = gee_map_get (_tmp14_, _tmp15_);
#line 352 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			alteration = (Alteration*) _tmp16_;
#line 355 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp17_ = alteration;
#line 355 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp18_ = alteration_has_detail (_tmp17_, "image", "orientation");
#line 355 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp18_) {
#line 1664 "MetadataWriter.c"
				GeeHashSet* _tmp19_ = NULL;
				GeeHashSet* _tmp21_ = NULL;
				LibraryPhoto* _tmp22_ = NULL;
#line 356 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp19_ = photos;
#line 356 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp19_ == NULL) {
#line 1672 "MetadataWriter.c"
					GeeHashSet* _tmp20_ = NULL;
#line 357 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp20_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 357 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 357 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					photos = _tmp20_;
#line 1680 "MetadataWriter.c"
				}
#line 359 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp21_ = photos;
#line 359 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp22_ = photo;
#line 359 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp22_);
#line 361 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 361 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 361 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 361 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 1696 "MetadataWriter.c"
			}
#line 365 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp23_ = alteration;
#line 365 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp24_ = alteration_get_details (_tmp23_, "metadata");
#line 365 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			details = _tmp24_;
#line 366 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp25_ = details;
#line 366 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp25_ == NULL) {
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (details);
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 367 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 1718 "MetadataWriter.c"
			}
			{
				GeeIterator* _detail_it = NULL;
				GeeCollection* _tmp26_ = NULL;
				GeeIterator* _tmp27_ = NULL;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp26_ = details;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp27_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ITERABLE, GeeIterable));
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_detail_it = _tmp27_;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				while (TRUE) {
#line 1732 "MetadataWriter.c"
					GeeIterator* _tmp28_ = NULL;
					gboolean _tmp29_ = FALSE;
					gchar* detail = NULL;
					GeeIterator* _tmp30_ = NULL;
					gpointer _tmp31_ = NULL;
					GeeHashSet* _tmp32_ = NULL;
					const gchar* _tmp33_ = NULL;
					gboolean _tmp34_ = FALSE;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp28_ = _detail_it;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp29_ = gee_iterator_next (_tmp28_);
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (!_tmp29_) {
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						break;
#line 1749 "MetadataWriter.c"
					}
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp30_ = _detail_it;
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp31_ = gee_iterator_get (_tmp30_);
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					detail = (gchar*) _tmp31_;
#line 371 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp32_ = self->priv->interested_photo_details;
#line 371 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp33_ = detail;
#line 371 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp34_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp33_);
#line 371 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (_tmp34_) {
#line 1765 "MetadataWriter.c"
						GeeHashSet* _tmp35_ = NULL;
						GeeHashSet* _tmp37_ = NULL;
						LibraryPhoto* _tmp38_ = NULL;
#line 372 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp35_ = photos;
#line 372 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						if (_tmp35_ == NULL) {
#line 1773 "MetadataWriter.c"
							GeeHashSet* _tmp36_ = NULL;
#line 373 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
							_tmp36_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
							_g_object_unref0 (photos);
#line 373 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
							photos = _tmp36_;
#line 1781 "MetadataWriter.c"
						}
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp37_ = photos;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp38_ = photo;
#line 375 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp38_);
#line 377 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_g_free0 (detail);
#line 377 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						break;
#line 1793 "MetadataWriter.c"
					}
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_free0 (detail);
#line 1797 "MetadataWriter.c"
				}
#line 370 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (_detail_it);
#line 1801 "MetadataWriter.c"
			}
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (details);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_alteration_unref0 (alteration);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 1811 "MetadataWriter.c"
		}
#line 344 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 1815 "MetadataWriter.c"
	}
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp39_ = photos;
#line 382 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp39_ != NULL) {
#line 1821 "MetadataWriter.c"
		GeeHashSet* _tmp40_ = NULL;
#line 383 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp40_ = photos;
#line 383 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_COLLECTION, GeeCollection), "alteration", FALSE);
#line 1827 "MetadataWriter.c"
	}
#line 342 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 1831 "MetadataWriter.c"
}


static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed) {
#line 386 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 386 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1840 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = destroyed;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_source_it = _tmp1_;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 1853 "MetadataWriter.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			DataSource* source = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			LibraryPhoto* _tmp8_ = NULL;
			GeeHashSet* _tmp9_ = NULL;
			LibraryPhoto* _tmp10_ = NULL;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp3_) {
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 1873 "MetadataWriter.c"
			}
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp4_ = _source_it;
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			source = (DataSource*) _tmp5_;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = source;
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 388 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = _tmp7_;
#line 389 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 389 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp8_);
#line 390 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = self->priv->importing_photos;
#line 390 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 390 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp10_);
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 1901 "MetadataWriter.c"
		}
#line 387 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 1905 "MetadataWriter.c"
	}
}


static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map) {
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp32_ = NULL;
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 395 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	photos = NULL;
#line 1919 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = map;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp3_);
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_object_it = _tmp5_;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 1946 "MetadataWriter.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			DataObject* object = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			GeeMap* _tmp10_ = NULL;
			DataObject* _tmp11_ = NULL;
			gpointer _tmp12_ = NULL;
			Alteration* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_ = FALSE;
			GeeHashSet* _tmp16_ = NULL;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp7_) {
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 1967 "MetadataWriter.c"
			}
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = _object_it;
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			object = (DataObject*) _tmp9_;
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp10_ = map;
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp11_ = object;
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp13_ = (Alteration*) _tmp12_;
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp14_ = alteration_has_detail (_tmp13_, "metadata", "name");
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp15_ = !_tmp14_;
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_alteration_unref0 (_tmp13_);
#line 397 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp15_) {
#line 398 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 398 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 1995 "MetadataWriter.c"
			}
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp16_ = photos;
#line 400 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp16_ == NULL) {
#line 2001 "MetadataWriter.c"
				GeeHashSet* _tmp17_ = NULL;
#line 401 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp17_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 401 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photos);
#line 401 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				photos = _tmp17_;
#line 2009 "MetadataWriter.c"
			}
			{
				GeeIterator* _media_it = NULL;
				DataObject* _tmp18_ = NULL;
				GeeCollection* _tmp19_ = NULL;
				GeeCollection* _tmp20_ = NULL;
				GeeIterator* _tmp21_ = NULL;
				GeeIterator* _tmp22_ = NULL;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp18_ = object;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp19_ = tag_get_sources (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_TAG, Tag));
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp20_ = _tmp19_;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp22_ = _tmp21_;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (_tmp20_);
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_media_it = _tmp22_;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				while (TRUE) {
#line 2034 "MetadataWriter.c"
					GeeIterator* _tmp23_ = NULL;
					gboolean _tmp24_ = FALSE;
					MediaSource* media = NULL;
					GeeIterator* _tmp25_ = NULL;
					gpointer _tmp26_ = NULL;
					LibraryPhoto* photo = NULL;
					MediaSource* _tmp27_ = NULL;
					LibraryPhoto* _tmp28_ = NULL;
					LibraryPhoto* _tmp29_ = NULL;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp23_ = _media_it;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp24_ = gee_iterator_next (_tmp23_);
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (!_tmp24_) {
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						break;
#line 2052 "MetadataWriter.c"
					}
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp25_ = _media_it;
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp26_ = gee_iterator_get (_tmp25_);
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					media = (MediaSource*) _tmp26_;
#line 404 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp27_ = media;
#line 404 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp28_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp27_) : NULL);
#line 404 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					photo = _tmp28_;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp29_ = photo;
#line 405 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (_tmp29_ != NULL) {
#line 2070 "MetadataWriter.c"
						GeeHashSet* _tmp30_ = NULL;
						LibraryPhoto* _tmp31_ = NULL;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp30_ = photos;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp31_ = photo;
#line 406 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp31_);
#line 2079 "MetadataWriter.c"
					}
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_object_unref0 (media);
#line 2085 "MetadataWriter.c"
				}
#line 403 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (_media_it);
#line 2089 "MetadataWriter.c"
			}
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 2093 "MetadataWriter.c"
		}
#line 396 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 2097 "MetadataWriter.c"
	}
#line 410 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp32_ = photos;
#line 410 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp32_ != NULL) {
#line 2103 "MetadataWriter.c"
		GeeHashSet* _tmp33_ = NULL;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp33_ = photos;
#line 411 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection), "tag renamed", FALSE);
#line 2109 "MetadataWriter.c"
	}
#line 394 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2113 "MetadataWriter.c"
}


static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking) {
	Tag* tag = NULL;
	ContainerSource* _tmp0_ = NULL;
	Tag* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp3_ = NULL;
	gboolean _tmp27_ = FALSE;
	GeeCollection* _tmp28_ = NULL;
#line 414 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 414 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 414 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 414 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 416 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = container;
#line 416 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_TAG, Tag));
#line 416 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	tag = _tmp1_;
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = added;
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp3_ != NULL) {
#line 2143 "MetadataWriter.c"
		gboolean _tmp4_ = FALSE;
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = relinking;
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = !_tmp4_;
#line 2149 "MetadataWriter.c"
	} else {
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = FALSE;
#line 2153 "MetadataWriter.c"
	}
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp2_) {
#line 2157 "MetadataWriter.c"
		GeeArrayList* added_photos = NULL;
		GeeArrayList* _tmp5_ = NULL;
		GeeArrayList* _tmp21_ = NULL;
		Tag* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
#line 419 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 419 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		added_photos = _tmp5_;
#line 2170 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp6_ = NULL;
			GeeIterator* _tmp7_ = NULL;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = added;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_source_it = _tmp7_;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			while (TRUE) {
#line 2183 "MetadataWriter.c"
				GeeIterator* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp10_ = NULL;
				gpointer _tmp11_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp12_ = NULL;
				LibraryPhoto* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				LibraryPhoto* _tmp15_ = NULL;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp8_ = _source_it;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp9_ = gee_iterator_next (_tmp8_);
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (!_tmp9_) {
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					break;
#line 2202 "MetadataWriter.c"
				}
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp10_ = _source_it;
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp11_ = gee_iterator_get (_tmp10_);
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				source = (DataSource*) _tmp11_;
#line 421 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp12_ = source;
#line 421 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp12_) : NULL);
#line 421 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				photo = _tmp13_;
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp15_ = photo;
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp15_ != NULL) {
#line 2220 "MetadataWriter.c"
					GeeHashSet* _tmp16_ = NULL;
					LibraryPhoto* _tmp17_ = NULL;
					gboolean _tmp18_ = FALSE;
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp16_ = self->priv->importing_photos;
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp17_ = photo;
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp18_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp14_ = !_tmp18_;
#line 2232 "MetadataWriter.c"
				} else {
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp14_ = FALSE;
#line 2236 "MetadataWriter.c"
				}
#line 422 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp14_) {
#line 2240 "MetadataWriter.c"
					GeeArrayList* _tmp19_ = NULL;
					LibraryPhoto* _tmp20_ = NULL;
#line 423 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp19_ = added_photos;
#line 423 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp20_ = photo;
#line 423 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp20_);
#line 2249 "MetadataWriter.c"
				}
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2255 "MetadataWriter.c"
			}
#line 420 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2259 "MetadataWriter.c"
		}
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp21_ = added_photos;
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp22_ = tag;
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp23_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_DATA_OBJECT, DataObject));
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp24_ = _tmp23_;
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp25_ = g_strdup_printf ("added to %s", _tmp24_);
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp26_ = _tmp25_;
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection), _tmp26_, FALSE);
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp26_);
#line 426 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp24_);
#line 418 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (added_photos);
#line 2281 "MetadataWriter.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp28_ = removed;
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp28_ != NULL) {
#line 2287 "MetadataWriter.c"
		gboolean _tmp29_ = FALSE;
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp29_ = unlinking;
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp27_ = !_tmp29_;
#line 2293 "MetadataWriter.c"
	} else {
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp27_ = FALSE;
#line 2297 "MetadataWriter.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp27_) {
#line 2301 "MetadataWriter.c"
		GeeArrayList* removed_photos = NULL;
		GeeArrayList* _tmp30_ = NULL;
		GeeArrayList* _tmp42_ = NULL;
		Tag* _tmp43_ = NULL;
		gchar* _tmp44_ = NULL;
		gchar* _tmp45_ = NULL;
		gchar* _tmp46_ = NULL;
		gchar* _tmp47_ = NULL;
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp30_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 430 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		removed_photos = _tmp30_;
#line 2314 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp31_ = NULL;
			GeeIterator* _tmp32_ = NULL;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp31_ = removed;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp32_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ITERABLE, GeeIterable));
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_source_it = _tmp32_;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			while (TRUE) {
#line 2327 "MetadataWriter.c"
				GeeIterator* _tmp33_ = NULL;
				gboolean _tmp34_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp35_ = NULL;
				gpointer _tmp36_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp37_ = NULL;
				LibraryPhoto* _tmp38_ = NULL;
				LibraryPhoto* _tmp39_ = NULL;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp33_ = _source_it;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp34_ = gee_iterator_next (_tmp33_);
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (!_tmp34_) {
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					break;
#line 2345 "MetadataWriter.c"
				}
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp35_ = _source_it;
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp36_ = gee_iterator_get (_tmp35_);
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				source = (DataSource*) _tmp36_;
#line 432 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp37_ = source;
#line 432 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp38_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp37_) : NULL);
#line 432 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				photo = _tmp38_;
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp39_ = photo;
#line 433 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp39_ != NULL) {
#line 2363 "MetadataWriter.c"
					GeeArrayList* _tmp40_ = NULL;
					LibraryPhoto* _tmp41_ = NULL;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp40_ = removed_photos;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp41_ = photo;
#line 434 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp41_);
#line 2372 "MetadataWriter.c"
				}
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2378 "MetadataWriter.c"
			}
#line 431 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2382 "MetadataWriter.c"
		}
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp42_ = removed_photos;
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp43_ = tag;
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp44_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, TYPE_DATA_OBJECT, DataObject));
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp45_ = _tmp44_;
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp46_ = g_strdup_printf ("removed from %s", _tmp45_);
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp47_ = _tmp46_;
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_COLLECTION, GeeCollection), _tmp47_, FALSE);
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp47_);
#line 437 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp45_);
#line 429 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (removed_photos);
#line 2404 "MetadataWriter.c"
	}
#line 414 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (tag);
#line 2408 "MetadataWriter.c"
}


static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources) {
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp12_ = NULL;
	ContainerSource* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
#line 441 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 441 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 441 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 442 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 442 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	photos = _tmp0_;
#line 2431 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = sources;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_source_it = _tmp2_;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 2444 "MetadataWriter.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			DataSource* source = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp7_ = NULL;
			LibraryPhoto* _tmp8_ = NULL;
			LibraryPhoto* _tmp9_ = NULL;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp3_ = _source_it;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp4_) {
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 2462 "MetadataWriter.c"
			}
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp5_ = _source_it;
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			source = (DataSource*) _tmp6_;
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = source;
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp7_) : NULL);
#line 444 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = _tmp8_;
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 445 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp9_ != NULL) {
#line 2480 "MetadataWriter.c"
				GeeArrayList* _tmp10_ = NULL;
				LibraryPhoto* _tmp11_ = NULL;
#line 446 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp10_ = photos;
#line 446 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp11_ = photo;
#line 446 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp11_);
#line 2489 "MetadataWriter.c"
			}
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 2495 "MetadataWriter.c"
		}
#line 443 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 2499 "MetadataWriter.c"
	}
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp12_ = photos;
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp13_ = container;
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp14_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp15_ = _tmp14_;
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp16_ = g_strdup_printf ("backlink removed from %s", _tmp15_);
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp17_ = _tmp16_;
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _tmp17_, FALSE);
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (_tmp17_);
#line 449 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (_tmp15_);
#line 441 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2521 "MetadataWriter.c"
}


static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_ = 0U;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 452 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 453 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_total;
#line 453 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = count;
#line 453 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_ + _tmp1_;
#line 459 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = report;
#line 459 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp2_) {
#line 2541 "MetadataWriter.c"
		guint _tmp3_ = 0U;
		guint _tmp4_ = 0U;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = self->priv->outstanding_completed;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = self->priv->outstanding_total;
#line 460 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp3_, _tmp4_);
#line 2550 "MetadataWriter.c"
	}
}


static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	gint _tmp2_ = 0;
	guint _tmp5_ = 0U;
	guint _tmp6_ = 0U;
	gboolean _tmp7_ = FALSE;
#line 463 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = self->priv->outstanding_total;
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = count;
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp1_ >= ((guint) _tmp2_)) {
#line 2570 "MetadataWriter.c"
		guint _tmp3_ = 0U;
		gint _tmp4_ = 0;
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = self->priv->outstanding_total;
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = count;
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = _tmp3_ - _tmp4_;
#line 2579 "MetadataWriter.c"
	} else {
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = (guint) 0;
#line 2583 "MetadataWriter.c"
	}
#line 464 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_;
#line 465 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = self->priv->outstanding_completed;
#line 465 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = self->priv->outstanding_total;
#line 465 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp5_ >= _tmp6_) {
#line 466 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 467 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2597 "MetadataWriter.c"
	}
#line 474 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = report;
#line 474 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp7_) {
#line 2603 "MetadataWriter.c"
		guint _tmp8_ = 0U;
		guint _tmp9_ = 0U;
#line 475 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp8_ = self->priv->outstanding_completed;
#line 475 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp9_ = self->priv->outstanding_total;
#line 475 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp8_, _tmp9_);
#line 2612 "MetadataWriter.c"
	}
}


static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_ = 0U;
	gint _tmp1_ = 0;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	gboolean _tmp4_ = FALSE;
#line 478 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 479 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_completed;
#line 479 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = count;
#line 479 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->outstanding_completed = _tmp0_ + _tmp1_;
#line 480 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = self->priv->outstanding_completed;
#line 480 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = self->priv->outstanding_total;
#line 480 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp2_ >= _tmp3_) {
#line 481 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 482 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2641 "MetadataWriter.c"
	}
#line 489 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = report;
#line 489 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp4_) {
#line 2647 "MetadataWriter.c"
		guint _tmp5_ = 0U;
		guint _tmp6_ = 0U;
#line 490 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = self->priv->outstanding_completed;
#line 490 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp6_ = self->priv->outstanding_total;
#line 490 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp5_, _tmp6_);
#line 2656 "MetadataWriter.c"
	}
}


static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const gchar* reason) {
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp18_ = NULL;
#line 493 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 493 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_ITERABLE (media_sources));
#line 493 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 494 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	photos = NULL;
#line 2672 "MetadataWriter.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterable* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = media_sources;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_media_it = _tmp1_;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 2685 "MetadataWriter.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			LibraryPhoto* _tmp8_ = NULL;
			GeeHashSet* _tmp9_ = NULL;
			LibraryPhoto* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			LibraryPhoto* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp2_ = _media_it;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp3_) {
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 2708 "MetadataWriter.c"
			}
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp4_ = _media_it;
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			media = (MediaSource*) _tmp5_;
#line 496 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = media;
#line 496 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp6_) : NULL);
#line 496 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = _tmp7_;
#line 497 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 497 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp8_ == NULL) {
#line 498 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 498 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 498 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 2732 "MetadataWriter.c"
			}
#line 501 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = self->priv->importing_photos;
#line 501 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 501 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp11_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp10_);
#line 501 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp11_) {
#line 502 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 502 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 502 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				continue;
#line 2748 "MetadataWriter.c"
			}
#line 504 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp12_ = photo;
#line 504 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp13_ = photo_is_master_metadata_dirty (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo));
#line 504 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp13_) {
#line 2756 "MetadataWriter.c"
				GeeArrayList* _tmp14_ = NULL;
				GeeArrayList* _tmp16_ = NULL;
				LibraryPhoto* _tmp17_ = NULL;
#line 505 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp14_ = photos;
#line 505 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (_tmp14_ == NULL) {
#line 2764 "MetadataWriter.c"
					GeeArrayList* _tmp15_ = NULL;
#line 506 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp15_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 506 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 506 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					photos = _tmp15_;
#line 2772 "MetadataWriter.c"
				}
#line 508 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp16_ = photos;
#line 508 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp17_ = photo;
#line 508 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 2780 "MetadataWriter.c"
			}
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (media);
#line 2786 "MetadataWriter.c"
		}
#line 495 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_media_it);
#line 2790 "MetadataWriter.c"
	}
#line 512 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp18_ = photos;
#line 512 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp18_ != NULL) {
#line 2796 "MetadataWriter.c"
		GeeArrayList* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
#line 513 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp19_ = photos;
#line 513 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp20_ = reason;
#line 513 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_, TRUE);
#line 2805 "MetadataWriter.c"
	}
#line 493 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2809 "MetadataWriter.c"
}


static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const gchar* reason, gboolean already_marked) {
	GeeCollection* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	GeeCollection* _tmp41_ = NULL;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	GError * _inner_error_ = NULL;
#line 517 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 517 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (photos));
#line 517 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = photos;
#line 518 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 518 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = _tmp1_;
#line 518 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp2_ == 0) {
#line 519 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 2840 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = photos;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_photo_it = _tmp4_;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 2854 "MetadataWriter.c"
			GeeIterator* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_ = NULL;
			gpointer _tmp8_ = NULL;
			LibraryPhoto* _tmp9_ = NULL;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp5_ = _photo_it;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp6_) {
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 2869 "MetadataWriter.c"
			}
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = _photo_it;
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 523 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 523 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp9_);
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 2883 "MetadataWriter.c"
		}
#line 522 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 2887 "MetadataWriter.c"
	}
#line 526 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp10_ = already_marked;
#line 526 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (!_tmp10_) {
#line 2893 "MetadataWriter.c"
		{
			LibraryPhotoSourceCollection* _tmp11_ = NULL;
			TransactionController* _tmp12_ = NULL;
			TransactionController* _tmp13_ = NULL;
			LibraryPhotoSourceCollection* _tmp21_ = NULL;
			TransactionController* _tmp22_ = NULL;
			TransactionController* _tmp23_ = NULL;
#line 528 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp11_ = library_photo_global;
#line 528 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp12_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 528 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp13_ = _tmp12_;
#line 528 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			transaction_controller_begin (_tmp13_);
#line 2909 "MetadataWriter.c"
			{
				GeeIterator* _photo_it = NULL;
				GeeCollection* _tmp14_ = NULL;
				GeeIterator* _tmp15_ = NULL;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp14_ = photos;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_photo_it = _tmp15_;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				while (TRUE) {
#line 2922 "MetadataWriter.c"
					GeeIterator* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					LibraryPhoto* photo = NULL;
					GeeIterator* _tmp18_ = NULL;
					gpointer _tmp19_ = NULL;
					LibraryPhoto* _tmp20_ = NULL;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp16_ = _photo_it;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp17_ = gee_iterator_next (_tmp16_);
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (!_tmp17_) {
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						break;
#line 2937 "MetadataWriter.c"
					}
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp18_ = _photo_it;
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					photo = (LibraryPhoto*) _tmp19_;
#line 531 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_tmp20_ = photo;
#line 531 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					photo_set_master_metadata_dirty (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo), TRUE, &_inner_error_);
#line 531 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 531 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_g_object_unref0 (photo);
#line 531 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_g_object_unref0 (_photo_it);
#line 2955 "MetadataWriter.c"
						goto __catch533_g_error;
					}
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 2960 "MetadataWriter.c"
				}
#line 530 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (_photo_it);
#line 2964 "MetadataWriter.c"
			}
#line 533 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp21_ = library_photo_global;
#line 533 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp22_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 533 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp23_ = _tmp22_;
#line 533 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			transaction_controller_commit (_tmp23_);
#line 2974 "MetadataWriter.c"
		}
		goto __finally533;
		__catch533_g_error:
		{
			GError* err = NULL;
			GError* _tmp24_ = NULL;
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			err = _inner_error_;
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 535 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp24_ = err;
#line 535 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp24_->domain == DATABASE_ERROR) {
#line 2989 "MetadataWriter.c"
				GError* _tmp25_ = NULL;
#line 536 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp25_ = err;
#line 536 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				app_window_database_error ((GError*) _tmp25_);
#line 2995 "MetadataWriter.c"
			} else {
				GError* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
#line 538 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp26_ = err;
#line 538 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp27_ = _tmp26_->message;
#line 538 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				g_error ("MetadataWriter.vala:538: Unable to mark metadata as dirty: %s", _tmp27_);
#line 3005 "MetadataWriter.c"
			}
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 3009 "MetadataWriter.c"
		}
		__finally533:
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 527 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			return;
#line 3020 "MetadataWriter.c"
		}
	}
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp29_ = self->priv->closed;
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp29_) {
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp28_ = TRUE;
#line 3029 "MetadataWriter.c"
	} else {
		gboolean _tmp30_ = FALSE;
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp30_ = self->priv->enabled;
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp28_ = !_tmp30_;
#line 3036 "MetadataWriter.c"
	}
#line 544 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp28_) {
#line 545 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 3042 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeCollection* _tmp31_ = NULL;
		GeeIterator* _tmp32_ = NULL;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp31_ = photos;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp32_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ITERABLE, GeeIterable));
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_photo_it = _tmp32_;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 3056 "MetadataWriter.c"
			GeeIterator* _tmp33_ = NULL;
			gboolean _tmp34_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp35_ = NULL;
			gpointer _tmp36_ = NULL;
			gboolean enqueued = FALSE;
			HashTimedQueue* _tmp37_ = NULL;
			LibraryPhoto* _tmp38_ = NULL;
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp33_ = _photo_it;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp34_ = gee_iterator_next (_tmp33_);
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp34_) {
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 3075 "MetadataWriter.c"
			}
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp35_ = _photo_it;
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp36_ = gee_iterator_get (_tmp35_);
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp36_;
#line 552 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp37_ = self->priv->dirty;
#line 552 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp38_ = photo;
#line 552 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp39_ = timed_queue_enqueue (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_TIMED_QUEUE, TimedQueue), _tmp38_);
#line 552 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			enqueued = _tmp39_;
#line 553 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp40_ = enqueued;
#line 553 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_vala_assert (_tmp40_, "enqueued");
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 3097 "MetadataWriter.c"
		}
#line 551 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 3101 "MetadataWriter.c"
	}
#line 556 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp41_ = photos;
#line 556 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp42_ = gee_collection_get_size (_tmp41_);
#line 556 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp43_ = _tmp42_;
#line 556 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_count_enqueued_work (self, _tmp43_, TRUE);
#line 3111 "MetadataWriter.c"
}


static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait) {
	HashTimedQueue* _tmp0_ = NULL;
	gboolean _tmp12_ = FALSE;
#line 559 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 560 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->dirty;
#line 560 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	timed_queue_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_TIMED_QUEUE, TimedQueue));
#line 3124 "MetadataWriter.c"
	{
		GeeIterator* _job_it = NULL;
		GeeHashMap* _tmp1_ = NULL;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_MAP, GeeMap));
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp4_);
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_job_it = _tmp6_;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		while (TRUE) {
#line 3151 "MetadataWriter.c"
			GeeIterator* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			MetadataWriterCommitJob* job = NULL;
			GeeIterator* _tmp9_ = NULL;
			gpointer _tmp10_ = NULL;
			MetadataWriterCommitJob* _tmp11_ = NULL;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = _job_it;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (!_tmp8_) {
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				break;
#line 3166 "MetadataWriter.c"
			}
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp9_ = _job_it;
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			job = (MetadataWriterCommitJob*) _tmp10_;
#line 563 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp11_ = job;
#line 563 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			background_job_cancel (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 3180 "MetadataWriter.c"
		}
#line 562 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_job_it);
#line 3184 "MetadataWriter.c"
	}
#line 565 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp12_ = wait;
#line 565 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp12_) {
#line 3190 "MetadataWriter.c"
		Workers* _tmp13_ = NULL;
#line 566 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp13_ = self->priv->workers;
#line 566 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		workers_wait_for_empty_queue (_tmp13_);
#line 3196 "MetadataWriter.c"
	}
#line 568 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, G_MAXINT, TRUE);
#line 3200 "MetadataWriter.c"
}


static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo) {
	gboolean result = FALSE;
	gboolean cancelled = FALSE;
	GeeHashMap* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	HashTimedQueue* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 571 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (self), FALSE);
#line 571 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), FALSE);
#line 572 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	cancelled = FALSE;
#line 574 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 574 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = photo;
#line 574 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 574 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp2_) {
#line 3227 "MetadataWriter.c"
		GeeHashMap* _tmp3_ = NULL;
		LibraryPhoto* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		MetadataWriterCommitJob* _tmp6_ = NULL;
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = self->priv->pending;
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = photo;
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp6_ = (MetadataWriterCommitJob*) _tmp5_;
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		background_job_cancel (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 575 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_background_job_unref0 (_tmp6_);
#line 576 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3246 "MetadataWriter.c"
	}
#line 579 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = self->priv->dirty;
#line 579 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp8_ = photo;
#line 579 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = timed_queue_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_TIMED_QUEUE, TimedQueue), _tmp8_);
#line 579 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp9_) {
#line 3256 "MetadataWriter.c"
		gboolean removed = FALSE;
		HashTimedQueue* _tmp10_ = NULL;
		LibraryPhoto* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		HashTimedQueue* _tmp14_ = NULL;
		LibraryPhoto* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
#line 580 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp10_ = self->priv->dirty;
#line 580 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp11_ = photo;
#line 580 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp12_ = timed_queue_remove_first (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_TIMED_QUEUE, TimedQueue), _tmp11_);
#line 580 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		removed = _tmp12_;
#line 581 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp13_ = removed;
#line 581 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_vala_assert (_tmp13_, "removed");
#line 583 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp14_ = self->priv->dirty;
#line 583 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp15_ = photo;
#line 583 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp16_ = timed_queue_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_TIMED_QUEUE, TimedQueue), _tmp15_);
#line 583 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_vala_assert (!_tmp16_, "!dirty.contains(photo)");
#line 585 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, FALSE);
#line 586 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3289 "MetadataWriter.c"
	}
#line 589 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	result = cancelled;
#line 589 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return result;
#line 3295 "MetadataWriter.c"
}


static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo) {
	gboolean _tmp0_ = FALSE;
	GeeSet* keywords = NULL;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GeeList* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
	MetadataWriterCommitJob* job = NULL;
	LibraryPhoto* _tmp16_ = NULL;
	GeeSet* _tmp17_ = NULL;
	MetadataWriterCommitJob* _tmp18_ = NULL;
	GeeHashMap* _tmp19_ = NULL;
	LibraryPhoto* _tmp20_ = NULL;
	MetadataWriterCommitJob* _tmp21_ = NULL;
	Workers* _tmp22_ = NULL;
	MetadataWriterCommitJob* _tmp23_ = NULL;
#line 592 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 592 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 593 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->enabled;
#line 593 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (!_tmp0_) {
#line 594 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 596 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 3328 "MetadataWriter.c"
	}
#line 599 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	keywords = NULL;
#line 600 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = tag_global;
#line 600 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = photo;
#line 600 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = tag_source_collection_fetch_for_source (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_MEDIA_SOURCE, MediaSource));
#line 600 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 601 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = tags;
#line 601 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp4_ != NULL) {
#line 3344 "MetadataWriter.c"
		GeeHashSet* _tmp5_ = NULL;
#line 602 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 602 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (keywords);
#line 602 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_SET, GeeSet);
#line 3352 "MetadataWriter.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp6_ = NULL;
			GeeIterator* _tmp7_ = NULL;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp6_ = tags;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tag_it = _tmp7_;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			while (TRUE) {
#line 3365 "MetadataWriter.c"
				GeeIterator* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
				Tag* tag = NULL;
				GeeIterator* _tmp10_ = NULL;
				gpointer _tmp11_ = NULL;
				GeeSet* _tmp12_ = NULL;
				Tag* _tmp13_ = NULL;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp8_ = _tag_it;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp9_ = gee_iterator_next (_tmp8_);
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (!_tmp9_) {
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					break;
#line 3383 "MetadataWriter.c"
				}
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp10_ = _tag_it;
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp11_ = gee_iterator_get (_tmp10_);
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				tag = (Tag*) _tmp11_;
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp12_ = keywords;
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp13_ = tag;
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp14_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp15_ = _tmp14_;
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 604 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_free0 (_tmp15_);
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 3405 "MetadataWriter.c"
			}
#line 603 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_tag_it);
#line 3409 "MetadataWriter.c"
		}
	}
#line 607 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp16_ = photo;
#line 607 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp17_ = keywords;
#line 607 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp18_ = metadata_writer_commit_job_new (self, _tmp16_, _tmp17_);
#line 607 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	job = _tmp18_;
#line 608 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp19_ = self->priv->pending;
#line 608 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp20_ = photo;
#line 608 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp21_ = job;
#line 608 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp20_, _tmp21_);
#line 614 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp22_ = self->priv->workers;
#line 614 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp23_ = job;
#line 614 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	workers_enqueue (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 592 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 592 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (tags);
#line 592 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (keywords);
#line 3440 "MetadataWriter.c"
}


static gpointer _background_job_ref0 (gpointer self) {
#line 618 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return self ? background_job_ref (self) : NULL;
#line 3447 "MetadataWriter.c"
}


static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j) {
	MetadataWriterCommitJob* job = NULL;
	BackgroundJob* _tmp0_ = NULL;
	MetadataWriterCommitJob* _tmp1_ = NULL;
	MetadataWriterCommitJob* _tmp2_ = NULL;
	GError* _tmp3_ = NULL;
	gboolean removed = FALSE;
	GeeHashMap* _tmp15_ = NULL;
	MetadataWriterCommitJob* _tmp16_ = NULL;
	LibraryPhoto* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	LibraryPhotoSourceCollection* _tmp20_ = NULL;
	TransactionController* _tmp21_ = NULL;
	TransactionController* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	MetadataWriterCommitJob* _tmp24_ = NULL;
	PhotoReimportMasterState* _tmp25_ = NULL;
	LibraryPhotoSourceCollection* _tmp57_ = NULL;
	TransactionController* _tmp58_ = NULL;
	TransactionController* _tmp59_ = NULL;
	GError * _inner_error_ = NULL;
#line 617 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 617 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 618 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = j;
#line 618 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob));
#line 618 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	job = _tmp1_;
#line 620 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = job;
#line 620 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = _tmp2_->err;
#line 620 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp3_ != NULL) {
#line 3489 "MetadataWriter.c"
		MetadataWriterCommitJob* _tmp4_ = NULL;
		LibraryPhoto* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		MetadataWriterCommitJob* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = job;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_->photo;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp6_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_OBJECT, DataObject));
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp7_ = _tmp6_;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp8_ = job;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp9_ = _tmp8_->err;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp10_ = _tmp9_->message;
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_warning ("MetadataWriter.vala:621: Unable to update metadata for %s: %s", _tmp7_, _tmp10_);
#line 621 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp7_);
#line 3515 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp11_ = NULL;
		LibraryPhoto* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp11_ = job;
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp12_ = _tmp11_->photo;
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp13_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_OBJECT, DataObject));
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp14_ = _tmp13_;
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_message ("MetadataWriter.vala:623: Completed writing metadata for %s", _tmp14_);
#line 623 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp14_);
#line 3533 "MetadataWriter.c"
	}
#line 625 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp15_ = self->priv->pending;
#line 625 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp16_ = job;
#line 625 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp17_ = _tmp16_->photo;
#line 625 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp18_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp17_, NULL);
#line 625 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	removed = _tmp18_;
#line 626 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp19_ = removed;
#line 626 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_vala_assert (_tmp19_, "removed");
#line 630 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp20_ = library_photo_global;
#line 630 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp21_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 630 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp22_ = _tmp21_;
#line 630 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	transaction_controller_begin (_tmp22_);
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp24_ = job;
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp25_ = _tmp24_->reimport_master_state;
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp25_ != NULL) {
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp23_ = TRUE;
#line 3565 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp26_ = NULL;
		PhotoReimportEditableState* _tmp27_ = NULL;
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp26_ = job;
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp27_ = _tmp26_->reimport_editable_state;
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp23_ = _tmp27_ != NULL;
#line 3575 "MetadataWriter.c"
	}
#line 632 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp23_) {
#line 3579 "MetadataWriter.c"
		LibraryPhoto* _tmp28_ = NULL;
		MetadataWriterCommitJob* _tmp29_ = NULL;
		LibraryPhoto* _tmp30_ = NULL;
		LibraryPhoto* _tmp31_ = NULL;
#line 635 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp28_ = self->priv->ignore_photo_alteration;
#line 635 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_vala_assert (_tmp28_ == NULL, "ignore_photo_alteration == null");
#line 636 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp29_ = job;
#line 636 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp30_ = _tmp29_->photo;
#line 636 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp31_ = _g_object_ref0 (_tmp30_);
#line 636 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 636 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->priv->ignore_photo_alteration = _tmp31_;
#line 3598 "MetadataWriter.c"
		{
			MetadataWriterCommitJob* _tmp32_ = NULL;
			PhotoReimportMasterState* _tmp33_ = NULL;
			MetadataWriterCommitJob* _tmp41_ = NULL;
			PhotoReimportEditableState* _tmp42_ = NULL;
#line 638 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp32_ = job;
#line 638 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp33_ = _tmp32_->reimport_master_state;
#line 638 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp33_ != NULL) {
#line 3610 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp34_ = NULL;
				LibraryPhoto* _tmp35_ = NULL;
				MetadataWriterCommitJob* _tmp36_ = NULL;
				PhotoReimportMasterState* _tmp37_ = NULL;
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp34_ = job;
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp35_ = _tmp34_->photo;
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp36_ = job;
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp37_ = _tmp36_->reimport_master_state;
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				photo_finish_update_master_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo), _tmp37_, &_inner_error_);
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3629 "MetadataWriter.c"
						goto __catch534_database_error;
					}
					{
						LibraryPhoto* _tmp38_ = NULL;
						MetadataWriterCommitJob* _tmp39_ = NULL;
						LibraryPhoto* _tmp40_ = NULL;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp38_ = self->priv->ignore_photo_alteration;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp39_ = job;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp40_ = _tmp39_->photo;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_vala_assert (_tmp38_ == _tmp40_, "ignore_photo_alteration == job.photo");
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3648 "MetadataWriter.c"
					}
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 639 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					return;
#line 3658 "MetadataWriter.c"
				}
			}
#line 641 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp41_ = job;
#line 641 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp42_ = _tmp41_->reimport_editable_state;
#line 641 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_tmp42_ != NULL) {
#line 3667 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp43_ = NULL;
				LibraryPhoto* _tmp44_ = NULL;
				MetadataWriterCommitJob* _tmp45_ = NULL;
				PhotoReimportEditableState* _tmp46_ = NULL;
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp43_ = job;
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp44_ = _tmp43_->photo;
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp45_ = job;
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp46_ = _tmp45_->reimport_editable_state;
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				photo_finish_update_editable_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, TYPE_PHOTO, Photo), _tmp46_, &_inner_error_);
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3686 "MetadataWriter.c"
						goto __catch534_database_error;
					}
					{
						LibraryPhoto* _tmp47_ = NULL;
						MetadataWriterCommitJob* _tmp48_ = NULL;
						LibraryPhoto* _tmp49_ = NULL;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp47_ = self->priv->ignore_photo_alteration;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp48_ = job;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_tmp49_ = _tmp48_->photo;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_vala_assert (_tmp47_ == _tmp49_, "ignore_photo_alteration == job.photo");
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3705 "MetadataWriter.c"
					}
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 642 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					return;
#line 3715 "MetadataWriter.c"
				}
			}
		}
		goto __finally534;
		__catch534_database_error:
		{
			GError* err = NULL;
			GError* _tmp50_ = NULL;
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			err = _inner_error_;
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 644 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp50_ = err;
#line 644 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			app_window_database_error (_tmp50_);
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 3734 "MetadataWriter.c"
		}
		__finally534:
		{
			LibraryPhoto* _tmp51_ = NULL;
			MetadataWriterCommitJob* _tmp52_ = NULL;
			LibraryPhoto* _tmp53_ = NULL;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp51_ = self->priv->ignore_photo_alteration;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp52_ = job;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp53_ = _tmp52_->photo;
#line 647 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_vala_assert (_tmp51_ == _tmp53_, "ignore_photo_alteration == job.photo");
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 648 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			self->priv->ignore_photo_alteration = NULL;
#line 3753 "MetadataWriter.c"
		}
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 637 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			return;
#line 3765 "MetadataWriter.c"
		}
	} else {
	}
	{
		MetadataWriterCommitJob* _tmp54_ = NULL;
		LibraryPhoto* _tmp55_ = NULL;
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp54_ = job;
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp55_ = _tmp54_->photo;
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_set_master_metadata_dirty (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, TYPE_PHOTO, Photo), FALSE, &_inner_error_);
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 3782 "MetadataWriter.c"
				goto __catch535_database_error;
			}
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 658 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			return;
#line 3793 "MetadataWriter.c"
		}
	}
	goto __finally535;
	__catch535_database_error:
	{
		GError* err = NULL;
		GError* _tmp56_ = NULL;
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		err = _inner_error_;
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 660 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp56_ = err;
#line 660 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		app_window_database_error (_tmp56_);
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 3811 "MetadataWriter.c"
	}
	__finally535:
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_background_job_unref0 (job);
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 657 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 3824 "MetadataWriter.c"
	}
#line 663 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp57_ = library_photo_global;
#line 663 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp58_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 663 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp59_ = _tmp58_;
#line 663 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	transaction_controller_commit (_tmp59_);
#line 665 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_count_completed_work (self, 1, TRUE);
#line 617 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 3838 "MetadataWriter.c"
}


static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j) {
	gboolean removed = FALSE;
	GeeHashMap* _tmp0_ = NULL;
	BackgroundJob* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 668 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 668 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 669 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 669 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = j;
#line 669 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob)->photo;
#line 669 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_, NULL);
#line 669 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	removed = _tmp3_;
#line 670 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_vala_assert (removed, "removed");
#line 672 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 3866 "MetadataWriter.c"
}


static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		data2 = param_values->data[0].v_pointer;
#line 3885 "MetadataWriter.c"
	} else {
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		data2 = closure->data;
#line 3891 "MetadataWriter.c"
	}
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 3897 "MetadataWriter.c"
}


static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_update_completed ((MetadataWriter*) self, job);
#line 3904 "MetadataWriter.c"
}


static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_on_update_cancelled ((MetadataWriter*) self, job);
#line 3911 "MetadataWriter.c"
}


static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
	MetadataWriterCommitJob* self = NULL;
	MetadataWriter* _tmp0_ = NULL;
	MetadataWriter* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	MetadataWriter* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
	LibraryPhoto* _tmp6_ = NULL;
	GeeSet* _tmp7_ = NULL;
	GeeSet* _tmp8_ = NULL;
#line 27 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (owner), NULL);
#line 27 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), NULL);
#line 27 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail ((keywords == NULL) || GEE_IS_SET (keywords), NULL);
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = g_cancellable_new ();
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = _tmp2_;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) background_job_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, G_TYPE_OBJECT, GObject), _metadata_writer_on_update_completed_completion_callback, _tmp1_, _tmp3_, _metadata_writer_on_update_cancelled_cancellation_callback, _tmp4_, NULL);
#line 28 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp3_);
#line 30 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = photo;
#line 30 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 30 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 30 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->photo = _tmp6_;
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = keywords;
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 31 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->current_keywords = _tmp8_;
#line 27 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return self;
#line 3964 "MetadataWriter.c"
}


static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
#line 27 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return metadata_writer_commit_job_construct (METADATA_WRITER_TYPE_COMMIT_JOB, owner, photo, keywords);
#line 3971 "MetadataWriter.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return self ? g_error_copy (self) : NULL;
#line 3978 "MetadataWriter.c"
}


static void metadata_writer_commit_job_real_execute (BackgroundJob* base) {
	MetadataWriterCommitJob * self;
	GError * _inner_error_ = NULL;
#line 34 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob);
#line 3987 "MetadataWriter.c"
	{
#line 36 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_master (self, &_inner_error_);
#line 36 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3993 "MetadataWriter.c"
			goto __catch536_g_error;
		}
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_editable (self, &_inner_error_);
#line 37 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4000 "MetadataWriter.c"
			goto __catch536_g_error;
		}
	}
	goto __finally536;
	__catch536_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_ = NULL;
		GError* _tmp1_ = NULL;
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		err = _inner_error_;
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = err;
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp1_ = _g_error_copy0 (_tmp0_);
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_error_free0 (self->err);
#line 39 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		self->err = _tmp1_;
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 4024 "MetadataWriter.c"
	}
	__finally536:
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 35 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 4035 "MetadataWriter.c"
	}
}


static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error) {
	gboolean skip_orientation = FALSE;
	LibraryPhoto* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	LibraryPhoto* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp5_ = NULL;
	PhotoMetadata* _tmp6_ = NULL;
	PhotoMetadata* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 43 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 47 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 47 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = photo_has_editable (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo));
#line 47 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	skip_orientation = _tmp1_;
#line 49 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = self->photo;
#line 49 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = photo_get_master_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO, Photo));
#line 49 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 49 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (!_tmp4_) {
#line 50 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 4072 "MetadataWriter.c"
	}
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = self->photo;
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = photo_get_master_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO, Photo), &_inner_error_);
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata = _tmp6_;
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 52 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 4086 "MetadataWriter.c"
	}
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = metadata;
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp8_ = skip_orientation;
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = metadata_writer_commit_job_update_metadata (self, _tmp7_, _tmp8_);
#line 53 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp9_) {
#line 4096 "MetadataWriter.c"
		LibraryPhoto* _tmp10_ = NULL;
		GFile* _tmp11_ = NULL;
		GFile* _tmp12_ = NULL;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp10_ = self->photo;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp11_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_MEDIA_SOURCE, MediaSource));
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp12_ = _tmp11_;
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp12_, "MetadataWriter.commit_master");
#line 54 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp12_);
#line 4110 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp13_ = NULL;
			PhotoMetadata* _tmp14_ = NULL;
			PhotoReimportMasterState* _tmp15_ = NULL;
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp13_ = self->photo;
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp14_ = metadata;
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo_persist_master_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo), _tmp14_, &_tmp15_, &_inner_error_);
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			self->reimport_master_state = _tmp15_;
#line 56 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4127 "MetadataWriter.c"
				goto __finally537;
			}
		}
		__finally537:
		{
			LibraryPhoto* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
#line 58 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp16_ = self->photo;
#line 58 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp17_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_MEDIA_SOURCE, MediaSource));
#line 58 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp18_ = _tmp17_;
#line 58 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp18_);
#line 58 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp18_);
#line 4146 "MetadataWriter.c"
		}
#line 55 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 55 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 55 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 55 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			return;
#line 4156 "MetadataWriter.c"
		}
	}
#line 43 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4161 "MetadataWriter.c"
}


static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error) {
	gboolean _tmp0_ = FALSE;
	LibraryPhoto* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp7_ = NULL;
	PhotoMetadata* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = photo_has_editable (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO, Photo));
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (!_tmp2_) {
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 4186 "MetadataWriter.c"
	} else {
		LibraryPhoto* _tmp3_ = NULL;
		PhotoFileFormat* _tmp4_ = NULL;
		PhotoFileFormat* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp3_ = self->photo;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp4_ = photo_get_editable_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO, Photo));
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp6_ = photo_file_format_can_write_metadata (*_tmp5_);
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp0_ = !_tmp6_;
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_free0 (_tmp5_);
#line 4204 "MetadataWriter.c"
	}
#line 64 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 65 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 4210 "MetadataWriter.c"
	}
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = self->photo;
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp8_ = photo_get_editable_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO, Photo), &_inner_error_);
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata = _tmp8_;
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 67 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		return;
#line 4224 "MetadataWriter.c"
	}
#line 68 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = metadata;
#line 68 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_vala_assert (_tmp9_ != NULL, "metadata != null");
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp10_ = metadata;
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp11_ = metadata_writer_commit_job_update_metadata (self, _tmp10_, FALSE);
#line 70 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp11_) {
#line 4236 "MetadataWriter.c"
		LibraryPhoto* _tmp12_ = NULL;
		GFile* _tmp13_ = NULL;
		GFile* _tmp14_ = NULL;
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp12_ = self->photo;
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp13_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo));
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp14_ = _tmp13_;
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp14_, "MetadataWriter.commit_editable");
#line 71 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp14_);
#line 4250 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp15_ = NULL;
			PhotoMetadata* _tmp16_ = NULL;
			PhotoReimportEditableState* _tmp17_ = NULL;
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp15_ = self->photo;
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp16_ = metadata;
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo_persist_editable_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO, Photo), _tmp16_, &_tmp17_, &_inner_error_);
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			self->reimport_editable_state = _tmp17_;
#line 73 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4267 "MetadataWriter.c"
				goto __finally538;
			}
		}
		__finally538:
		{
			LibraryPhoto* _tmp18_ = NULL;
			GFile* _tmp19_ = NULL;
			GFile* _tmp20_ = NULL;
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp18_ = self->photo;
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp19_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO, Photo));
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp20_ = _tmp19_;
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp20_);
#line 75 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp20_);
#line 4286 "MetadataWriter.c"
		}
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 72 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			return;
#line 4296 "MetadataWriter.c"
		}
	}
#line 63 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4301 "MetadataWriter.c"
}


static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata, gboolean skip_orientation) {
	gboolean result = FALSE;
	gboolean changed = FALSE;
	gchar* current_title = NULL;
	LibraryPhoto* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gchar* current_comment = NULL;
	LibraryPhoto* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoMetadata* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	Rating current_rating = 0;
	LibraryPhoto* _tmp18_ = NULL;
	Rating _tmp19_ = 0;
	Rating _tmp20_ = 0;
	PhotoMetadata* _tmp21_ = NULL;
	Rating _tmp22_ = 0;
	time_t current_exposure_time = 0;
	LibraryPhoto* _tmp25_ = NULL;
	time_t _tmp26_ = 0;
	time_t metadata_exposure_time = 0;
	MetadataDateTime* metadata_exposure_date_time = NULL;
	PhotoMetadata* _tmp27_ = NULL;
	MetadataDateTime* _tmp28_ = NULL;
	MetadataDateTime* _tmp29_ = NULL;
	time_t _tmp32_ = 0;
	time_t _tmp33_ = 0;
	GeeSet* safe_keywords = NULL;
	GeeHashSet* _tmp39_ = NULL;
	GeeSet* _tmp40_ = NULL;
	GeeSet* _tmp53_ = NULL;
	PhotoMetadata* _tmp54_ = NULL;
	GeeSet* _tmp55_ = NULL;
	GeeSet* _tmp56_ = NULL;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp61_ = FALSE;
	gboolean _tmp69_ = FALSE;
#line 80 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self), FALSE);
#line 80 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 81 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	changed = FALSE;
#line 84 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 84 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource));
#line 84 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	current_title = _tmp1_;
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = current_title;
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = metadata;
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp4_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = _tmp4_;
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp6_ = g_strcmp0 (_tmp2_, _tmp5_) != 0;
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (_tmp5_);
#line 85 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp6_) {
#line 4377 "MetadataWriter.c"
		PhotoMetadata* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp7_ = metadata;
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp8_ = current_title;
#line 86 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_title (_tmp7_, _tmp8_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 87 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		changed = TRUE;
#line 4388 "MetadataWriter.c"
	}
#line 91 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = self->photo;
#line 91 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp10_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_MEDIA_SOURCE, MediaSource));
#line 91 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	current_comment = _tmp10_;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp11_ = current_comment;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp12_ = metadata;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp13_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp14_ = _tmp13_;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp15_ = g_strcmp0 (_tmp11_, _tmp14_) != 0;
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (_tmp14_);
#line 92 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp15_) {
#line 4410 "MetadataWriter.c"
		PhotoMetadata* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp16_ = metadata;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp17_ = current_comment;
#line 93 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_comment (_tmp16_, _tmp17_);
#line 94 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		changed = TRUE;
#line 4421 "MetadataWriter.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp18_ = self->photo;
#line 98 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp19_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_MEDIA_SOURCE, MediaSource));
#line 98 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	current_rating = _tmp19_;
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp20_ = current_rating;
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp21_ = metadata;
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp22_ = photo_metadata_get_rating (_tmp21_);
#line 99 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp20_ != _tmp22_) {
#line 4437 "MetadataWriter.c"
		PhotoMetadata* _tmp23_ = NULL;
		Rating _tmp24_ = 0;
#line 100 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp23_ = metadata;
#line 100 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp24_ = current_rating;
#line 100 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_rating (_tmp23_, _tmp24_);
#line 101 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		changed = TRUE;
#line 4448 "MetadataWriter.c"
	}
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp25_ = self->photo;
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp26_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_MEDIA_SOURCE, MediaSource));
#line 105 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	current_exposure_time = _tmp26_;
#line 106 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_exposure_time = (time_t) 0;
#line 107 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp27_ = metadata;
#line 107 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp28_ = photo_metadata_get_exposure_date_time (_tmp27_);
#line 107 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_exposure_date_time = _tmp28_;
#line 108 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp29_ = metadata_exposure_date_time;
#line 108 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp29_ != NULL) {
#line 4468 "MetadataWriter.c"
		MetadataDateTime* _tmp30_ = NULL;
		time_t _tmp31_ = 0;
#line 109 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp30_ = metadata_exposure_date_time;
#line 109 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp31_ = metadata_date_time_get_timestamp (_tmp30_);
#line 109 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		metadata_exposure_time = _tmp31_;
#line 4477 "MetadataWriter.c"
	}
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp32_ = current_exposure_time;
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp33_ = metadata_exposure_time;
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp32_ != _tmp33_) {
#line 4485 "MetadataWriter.c"
		MetadataDateTime* _tmp34_ = NULL;
		time_t _tmp35_ = 0;
		PhotoMetadata* _tmp38_ = NULL;
#line 111 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp35_ = current_exposure_time;
#line 111 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (_tmp35_ != ((time_t) 0)) {
#line 4493 "MetadataWriter.c"
			time_t _tmp36_ = 0;
			MetadataDateTime* _tmp37_ = NULL;
#line 112 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp36_ = current_exposure_time;
#line 112 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp37_ = metadata_date_time_new (_tmp36_);
#line 112 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp34_);
#line 112 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp34_ = _tmp37_;
#line 4504 "MetadataWriter.c"
		} else {
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp34_);
#line 113 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp34_ = NULL;
#line 4510 "MetadataWriter.c"
		}
#line 111 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp38_ = metadata;
#line 111 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_exposure_date_time (_tmp38_, _tmp34_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 114 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		changed = TRUE;
#line 110 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_metadata_date_time_unref0 (_tmp34_);
#line 4520 "MetadataWriter.c"
	}
#line 118 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp39_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 118 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	safe_keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_SET, GeeSet);
#line 127 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp40_ = self->current_keywords;
#line 127 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp40_ != NULL) {
#line 4530 "MetadataWriter.c"
		{
			GeeIterator* _tmp_it = NULL;
			GeeSet* _tmp41_ = NULL;
			GeeIterator* _tmp42_ = NULL;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp41_ = self->current_keywords;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp42_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ITERABLE, GeeIterable));
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp_it = _tmp42_;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			while (TRUE) {
#line 4543 "MetadataWriter.c"
				GeeIterator* _tmp43_ = NULL;
				gboolean _tmp44_ = FALSE;
				gchar* tmp = NULL;
				GeeIterator* _tmp45_ = NULL;
				gpointer _tmp46_ = NULL;
				Tag* tag = NULL;
				const gchar* _tmp47_ = NULL;
				Tag* _tmp48_ = NULL;
				GeeSet* _tmp49_ = NULL;
				Tag* _tmp50_ = NULL;
				gchar* _tmp51_ = NULL;
				gchar* _tmp52_ = NULL;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp43_ = _tmp_it;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp44_ = gee_iterator_next (_tmp43_);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				if (!_tmp44_) {
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
					break;
#line 4564 "MetadataWriter.c"
				}
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp45_ = _tmp_it;
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp46_ = gee_iterator_get (_tmp45_);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				tmp = (gchar*) _tmp46_;
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp47_ = tmp;
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp48_ = tag_for_path (_tmp47_);
#line 129 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				tag = _tmp48_;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp49_ = safe_keywords;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp50_ = tag;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp51_ = tag_get_user_visible_name (_tmp50_);
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_tmp52_ = _tmp51_;
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_COLLECTION, GeeCollection), _tmp52_);
#line 130 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_free0 (_tmp52_);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
				_g_free0 (tmp);
#line 4594 "MetadataWriter.c"
			}
#line 128 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp_it);
#line 4598 "MetadataWriter.c"
		}
	}
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp53_ = safe_keywords;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp54_ = metadata;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp55_ = photo_metadata_get_keywords (_tmp54_, NULL, NULL, NULL);
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp56_ = _tmp55_;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp57_ = equal_sets (_tmp53_, _tmp56_);
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp58_ = !_tmp57_;
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp56_);
#line 134 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp58_) {
#line 4617 "MetadataWriter.c"
		PhotoMetadata* _tmp59_ = NULL;
		GeeSet* _tmp60_ = NULL;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp59_ = metadata;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp60_ = self->current_keywords;
#line 135 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_keywords (_tmp59_, G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_COLLECTION, GeeCollection), PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 136 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		changed = TRUE;
#line 4628 "MetadataWriter.c"
	}
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp61_ = skip_orientation;
#line 140 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (!_tmp61_) {
#line 4634 "MetadataWriter.c"
		Orientation current_orientation = 0;
		LibraryPhoto* _tmp62_ = NULL;
		Orientation _tmp63_ = 0;
		Orientation _tmp64_ = 0;
		PhotoMetadata* _tmp65_ = NULL;
		Orientation _tmp66_ = 0;
#line 141 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp62_ = self->photo;
#line 141 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp63_ = photo_get_orientation (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_PHOTO, Photo));
#line 141 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		current_orientation = _tmp63_;
#line 142 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp64_ = current_orientation;
#line 142 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp65_ = metadata;
#line 142 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp66_ = photo_metadata_get_orientation (_tmp65_);
#line 142 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		if (_tmp64_ != _tmp66_) {
#line 4655 "MetadataWriter.c"
			PhotoMetadata* _tmp67_ = NULL;
			Orientation _tmp68_ = 0;
#line 143 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp67_ = metadata;
#line 143 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			_tmp68_ = current_orientation;
#line 143 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			photo_metadata_set_orientation (_tmp67_, _tmp68_);
#line 144 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
			changed = TRUE;
#line 4666 "MetadataWriter.c"
		}
	}
#line 149 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp69_ = changed;
#line 149 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	if (_tmp69_) {
#line 4673 "MetadataWriter.c"
		PhotoMetadata* _tmp70_ = NULL;
#line 150 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		_tmp70_ = metadata;
#line 150 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
		photo_metadata_set_software (_tmp70_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 4679 "MetadataWriter.c"
	}
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	result = changed;
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (safe_keywords);
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_metadata_date_time_unref0 (metadata_exposure_date_time);
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (current_comment);
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_free0 (current_title);
#line 152 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	return result;
#line 4693 "MetadataWriter.c"
}


static void metadata_writer_commit_job_class_init (MetadataWriterCommitJobClass * klass) {
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_commit_job_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->finalize = metadata_writer_commit_job_finalize;
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->execute = metadata_writer_commit_job_real_execute;
#line 4704 "MetadataWriter.c"
}


static void metadata_writer_commit_job_instance_init (MetadataWriterCommitJob * self) {
#line 23 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->reimport_master_state = NULL;
#line 24 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->reimport_editable_state = NULL;
#line 25 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->err = NULL;
#line 4715 "MetadataWriter.c"
}


static void metadata_writer_commit_job_finalize (BackgroundJob* obj) {
	MetadataWriterCommitJob * self;
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob);
#line 21 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 22 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 23 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 24 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 25 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_error_free0 (self->err);
#line 20 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (metadata_writer_commit_job_parent_class)->finalize (obj);
#line 4735 "MetadataWriter.c"
}


static GType metadata_writer_commit_job_get_type (void) {
	static volatile gsize metadata_writer_commit_job_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_commit_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterCommitJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_commit_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriterCommitJob), 0, (GInstanceInitFunc) metadata_writer_commit_job_instance_init, NULL };
		GType metadata_writer_commit_job_type_id;
		metadata_writer_commit_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "MetadataWriterCommitJob", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_commit_job_type_id__volatile, metadata_writer_commit_job_type_id);
	}
	return metadata_writer_commit_job_type_id__volatile;
}


static void metadata_writer_class_init (MetadataWriterClass * klass) {
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_type_class_add_private (klass, sizeof (MetadataWriterPrivate));
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	G_OBJECT_CLASS (klass)->finalize = metadata_writer_finalize;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_new ("progress", TYPE_METADATA_WRITER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 4760 "MetadataWriter.c"
}


static void metadata_writer_instance_init (MetadataWriter * self) {
	Workers* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	GeeHashSet* _tmp2_ = NULL;
	GeeHashSet* _tmp3_ = NULL;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv = METADATA_WRITER_GET_PRIVATE (self);
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = workers_new (1, FALSE);
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->workers = _tmp0_;
#line 159 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->enabled = FALSE;
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_TYPE_COMMIT_JOB, (GBoxedCopyFunc) background_job_ref, background_job_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->pending = _tmp1_;
#line 162 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 162 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->interested_photo_details = _tmp2_;
#line 163 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->ignore_photo_alteration = NULL;
#line 164 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->outstanding_total = (guint) 0;
#line 165 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->outstanding_completed = (guint) 0;
#line 166 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->closed = FALSE;
#line 167 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->pause_count = 0;
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self->priv->importing_photos = _tmp3_;
#line 4799 "MetadataWriter.c"
}


static void metadata_writer_finalize (GObject* obj) {
	MetadataWriter * self;
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	LibraryPhotoSourceCollection* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	LibraryPhotoSourceCollection* _tmp5_ = NULL;
	guint _tmp6_ = 0U;
	LibraryPhotoSourceCollection* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	LibraryPhotoSourceCollection* _tmp9_ = NULL;
	guint _tmp10_ = 0U;
	LibraryPhotoSourceCollection* _tmp11_ = NULL;
	guint _tmp12_ = 0U;
	LibraryPhotoSourceCollection* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
	LibraryPhotoSourceCollection* _tmp15_ = NULL;
	guint _tmp16_ = 0U;
	TagSourceCollection* _tmp17_ = NULL;
	guint _tmp18_ = 0U;
	TagSourceCollection* _tmp19_ = NULL;
	guint _tmp20_ = 0U;
	TagSourceCollection* _tmp21_ = NULL;
	guint _tmp22_ = 0U;
	TagSourceCollection* _tmp23_ = NULL;
	guint _tmp24_ = 0U;
	TagSourceCollection* _tmp25_ = NULL;
	guint _tmp26_ = 0U;
	Application* _tmp27_ = NULL;
	Application* _tmp28_ = NULL;
	guint _tmp29_ = 0U;
	LibraryMonitorPool* _tmp30_ = NULL;
	LibraryMonitorPool* _tmp31_ = NULL;
	guint _tmp32_ = 0U;
	LibraryMonitorPool* _tmp33_ = NULL;
	LibraryMonitorPool* _tmp34_ = NULL;
	guint _tmp35_ = 0U;
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_WRITER, MetadataWriter);
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp0_ = config_facade_get_instance ();
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("commit-metadata-to-masters-changed", TYPE_CONFIGURATION_FACADE, &_tmp2_, NULL, FALSE);
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed, self);
#line 213 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 215 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp3_ = library_photo_global;
#line 215 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp4_, NULL, FALSE);
#line 215 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self);
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp5_ = library_photo_global;
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 216 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self);
#line 217 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp7_ = library_photo_global;
#line 217 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 217 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self);
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp9_ = library_photo_global;
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp10_, NULL, FALSE);
#line 218 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self);
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp12_, NULL, FALSE);
#line 219 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp14_, NULL, FALSE);
#line 220 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp16_, NULL, FALSE);
#line 221 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self);
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp18_, NULL, FALSE);
#line 223 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self);
#line 224 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 224 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp20_, NULL, FALSE);
#line 224 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 225 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp21_ = tag_global;
#line 225 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp22_, NULL, FALSE);
#line 225 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, 0, NULL, (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self);
#line 226 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp23_ = tag_global;
#line 226 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp24_, NULL, FALSE);
#line 226 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp25_ = tag_global;
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp26_, NULL, FALSE);
#line 227 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp27_ = application_get_instance ();
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp28_ = _tmp27_;
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("exiting", TYPE_APPLICATION, &_tmp29_, NULL, FALSE);
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp28_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp29_, 0, NULL, (GCallback) _metadata_writer_on_application_exiting_application_exiting, self);
#line 229 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_application_unref0 (_tmp28_);
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp30_ = library_monitor_pool_get_instance ();
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp31_ = _tmp30_;
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-installed", TYPE_LIBRARY_MONITOR_POOL, &_tmp32_, NULL, FALSE);
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp31_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp32_, 0, NULL, (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self);
#line 231 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp31_);
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp33_ = library_monitor_pool_get_instance ();
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_tmp34_ = _tmp33_;
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-destroyed", TYPE_LIBRARY_MONITOR_POOL, &_tmp35_, NULL, FALSE);
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp34_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp35_, 0, NULL, (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self);
#line 232 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp34_);
#line 158 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_workers_unref0 (self->priv->workers);
#line 160 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 161 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->pending);
#line 162 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->interested_photo_details);
#line 163 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 168 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->importing_photos);
#line 14 "/builddir/build/BUILD/shotwell-0.20.2/src/MetadataWriter.vala"
	G_OBJECT_CLASS (metadata_writer_parent_class)->finalize (obj);
#line 4969 "MetadataWriter.c"
}


GType metadata_writer_get_type (void) {
	static volatile gsize metadata_writer_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriter), 0, (GInstanceInitFunc) metadata_writer_instance_init, NULL };
		GType metadata_writer_type_id;
		metadata_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "MetadataWriter", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_type_id__volatile, metadata_writer_type_id);
	}
	return metadata_writer_type_id__volatile;
}



